/* ****************************************** */
/* Emu71: HP-71B software emulator for PC     */
/*                                            */
/* desas.c   disassembler module for Emu71    */
/*                                            */
/* Version 2.4, J-F Garnier 1996-2007         */
/* ****************************************** */


#include <stdlib.h>
#include <string.h>
#include <stdio.h>

/* fonctions extern */
extern int ch_label(long adr, char *s); /* trans.c */
extern int hextoint(char c);    /* monit.c */

extern char from;       /* desassembling code in ROM */


/* prototypes */
void champ_a(char *ligne,char c);
void champ_b(char *ligne,char c);
void champ_f(char *ligne,char c);
void champ_x1(char *ligne,char c);
void champ_dec(char *ligne,char c);
void champ_hex(char *ligne,char *codes,int n);
void champ_rel(long addr, char *ligne, char *codes, int n);
void champ_abs(char *ligne, char *codes);
void champ_goyes(long addr, char *ligne, char *codes);

int desas0(char *codes,char *ligne);
int desas1(char *codes,char *ligne);
int desas2(char *codes,char *ligne);
int desas3(char *codes,char *ligne);
int desas4(long addr,char *codes,char *ligne);
int desas5(long addr,char *codes,char *ligne);
int desas6(long addr,char *codes,char *ligne);
int desas7(long addr,char *codes,char *ligne);
int desas8(long addr,char *codes,char *ligne);
int desas9(long addr,char *codes,char *ligne);
int desasA(char *codes,char *ligne);
int desasB(char *codes,char *ligne);
int desasC(char *codes,char *ligne);
int desasD(char *codes,char *ligne);
int desasE(char *codes,char *ligne);
int desasF(char *codes,char *ligne);
int desas80(long addr,char *codes,char *ligne);
int desas81(char *codes,char *ligne);
int desas82(char *codes,char *ligne);
int desas83(long addr,char *codes,char *ligne);
int desas84(char *codes,char *ligne);
int desas85(char *codes,char *ligne);
int desas86(long addr,char *codes,char *ligne);
int desas87(long addr,char *codes,char *ligne);
int desas88(long addr,char *codes,char *ligne);
int desas89(long addr,char *codes,char *ligne);
int desas8A(long addr,char *codes,char *ligne);
int desas8B(long addr,char *codes,char *ligne);
int desas8C(long addr,char *codes,char *ligne);
int desas8D(char *codes,char *ligne);
int desas8E(long addr,char *codes,char *ligne);
int desas8F(char *codes,char *ligne);
int desas808(long addr,char *codes,char *ligne);
int desas818(char *codes,char *ligne);
int desas819(char *codes,char *ligne);
int desas81A(char *codes,char *ligne);
int desas81B(char *codes,char *ligne);


int desas(long addr, char *codes, char *ligne)
{
  int n;

  switch (codes[0]) {
    case '0' : n=desas0(codes,ligne);       break;
    case '1' : n=desas1(codes,ligne);       break;
    case '2' : n=desas2(codes,ligne);       break;
    case '3' : n=desas3(codes,ligne);       break;
    case '4' : n=desas4(addr,codes,ligne);  break;
    case '5' : n=desas5(addr,codes,ligne);  break;
    case '6' : n=desas6(addr,codes,ligne);  break;
    case '7' : n=desas7(addr,codes,ligne);  break;
    case '8' : n=desas8(addr,codes,ligne);  break;
    case '9' : n=desas9(addr,codes,ligne);  break;
    case 'A' : n=desasA(codes,ligne);       break;
    case 'B' : n=desasB(codes,ligne);       break;
    case 'C' : n=desasC(codes,ligne);       break;
    case 'D' : n=desasD(codes,ligne);       break;
    case 'E' : n=desasE(codes,ligne);       break;
    case 'F' : n=desasF(codes,ligne);       break;
  }
  return(n);
}

int desas8(long addr, char *codes, char *ligne)
{
  int n;

  switch (codes[1]) {
    case '0' : n=desas80(addr,codes,ligne); break;
    case '1' : n=desas81(codes,ligne);      break;
    case '2' : n=desas82(codes,ligne);      break;
    case '3' : n=desas83(addr,codes,ligne); break;
    case '4' : n=desas84(codes,ligne);      break;
    case '5' : n=desas85(codes,ligne);      break;
    case '6' : n=desas86(addr,codes,ligne); break;
    case '7' : n=desas87(addr,codes,ligne); break;
    case '8' : n=desas88(addr,codes,ligne); break;
    case '9' : n=desas89(addr,codes,ligne); break;
    case 'A' : n=desas8A(addr,codes,ligne); break;
    case 'B' : n=desas8B(addr,codes,ligne); break;
    case 'C' : n=desas8C(addr,codes,ligne); break;
    case 'D' : n=desas8D(codes,ligne);      break;
    case 'E' : n=desas8E(addr,codes,ligne); break;
    case 'F' : n=desas8F(codes,ligne);      break;
  }
  return(n);
}





int desas0(char *codes,char *ligne)
{
  int c;
  char *mnemo[]= { "RTNSXM", "RTN", "RTNSC", "RTNCC",
		   "SETHEX", "SETDEC", "RSTK=C", "C=RSTK",
		   "CLRST", "C=ST", "ST=C", "CSTEX",
		   "P=P+1", "P=P-1", "", "RTI" } ;
  char *mnemoE[]={ "A=A&B ", "B=B&C ", "C=C&A ", "D=D&C ",
		   "B=B&A ", "C=C&B ", "A=A&C ", "C=C&D ",
		   "A=A!B ", "B=B!C ", "C=C!A ", "D=D!C ",
		   "B=B!A ", "C=C!B ", "A=A!C ", "C=C!D " } ;

  if (codes[1] != 'E') {
    c=hextoint(codes[1]);
    strcpy(ligne,mnemo[c]);
    return(2);
  }
  else {
    c=hextoint(codes[3]);
    strcpy(ligne,mnemoE[c]);
    champ_f(ligne,codes[2]);
    return(4);
  }
}


int desas1(char *codes,char *ligne)
{
  int c;
  int lg;
  char *mnemo[] =
  { "R0=A", "R1=A", "R2=A", "R3=A", "R4=A", "R5=A", "R6=A", "R7=A",
    "R0=C", "R1=C", "R2=C", "R3=C", "R4=C", "R5=C", "R6=C", "R7=C",
    "A=R0", "A=R1", "A=R2", "A=R3", "A=R4", "A=R7", "A=R7", "A=R7",
    "C=R0", "C=R1", "C=R2", "C=R3", "C=R4", "C=R5", "C=R6", "C=R7",
    "AR0EX","AR1EX","AR2EX","AR3EX","AR4EX","AR5EX","AR6EX","AR7EX",
    "CR0EX","CR1EX","CR2EX","CR3EX","CR4EX","CR5EX","CR6EX","CR7EX",
    "D0=A", "D1=A", "AD0EX","AD1EX","D0=C", "D1=C", "CD0EX","CD1EX",
    "D0=AS","D1=AS","AD0XS","AD1XS","D0=CS","D1=CS","CD0XS","CD1XS" } ;

  char *mnemo4[]={ "DAT0=A", "DAT1=A", "A=DAT0", "A=DAT1",
		   "DAT0=C", "DAT1=C", "C=DAT0", "C=DAT1" } ;

  char *mnemo6[]={ "D0=D0+", "D1=D1+",
		   "D0=D0-", "D0=(2)", "D0=(4)", "D0=(5)",
		   "D1=D1-", "D1=(2)", "D1=(4)", "D1=(5)" } ;

  switch (codes[1]) {
    case '0':
    case '1':
    case '2':
    case '3':
      c=hextoint(codes[1])*16+hextoint(codes[2]);
      strcpy(ligne,mnemo[c]);
      lg=3;
      break;
    case '4':
      c=hextoint(codes[2])&7;
      strcpy(ligne,mnemo4[c]);
      if (codes[2]<='7') strcat(ligne," A"); else strcat(ligne," B");
      lg=3;
      break;
    case '5':
      c=hextoint(codes[2])&7;
      strcpy(ligne,mnemo4[c]);
      if (codes[2]<='7')
	champ_a(ligne,codes[3]);
      else
	champ_x1(ligne,codes[3]);
      lg=4;
      break;
    case '6':
    case '7':
    case '8':
    case 'C':
      c=hextoint(codes[1])-6;
      strcpy(ligne,mnemo6[c]);
      champ_x1(ligne,codes[2]);
      lg=3;
      break;
    case '9':
    case 'D':
      c=hextoint(codes[1])-6;
      strcpy(ligne,mnemo6[c]);
      champ_hex(ligne,&codes[2],2);
      lg=4;
      break;
    case 'A':
    case 'E':
      c=hextoint(codes[1])-6;
      strcpy(ligne,mnemo6[c]);
      champ_hex(ligne,&codes[2],4);
      lg=6;
      break;
    case 'B':
    case 'F':
      c=hextoint(codes[1])-6;
      strcpy(ligne,mnemo6[c]);
      champ_hex(ligne,&codes[2],5);
      lg=7;
      break;
  }
  return(lg);
}

int desas2(char *codes,char *ligne)
{
  strcpy(ligne,"P=    ");
  champ_dec(ligne,codes[1]);
  return(2);
}

int desas3(char *codes,char *ligne)
{
  int c;

  c=hextoint(codes[1])+1;
  if (c==5)
    strcpy(ligne,"LC(5) ");
  else
    strcpy(ligne,"LCHEX ");
  champ_hex(ligne,&codes[2],c);
  return(c+2);
}

int desas4(long addr,char *codes,char *ligne)
{
  if ( (codes[1]=='0') && (codes[2]=='0') ) {
    strcpy(ligne,"RTNC");
  }
  else if ( (codes[1]=='2') && (codes[2]=='0') ) {
    strcpy(ligne,"NOP3");
  }
  else {
    strcpy(ligne,"GOC   ");
    champ_rel(addr+1,ligne,&codes[1],2);
  }
  return(3);
}

int desas5(long addr, char *codes,char *ligne)
{
  if ( (codes[1]=='0') && (codes[2]=='0') ) {
    strcpy(ligne,"RTNNC");
  }
  else {
    strcpy(ligne,"GONC  ");
    champ_rel(addr+1,ligne,&codes[1],2);
  }
  return(3);
}

int desas6(long addr, char *codes,char *ligne)
{
  if ( (codes[1]=='3') && (codes[2]=='0') && (codes[3]=='0') ) {
    strcpy(ligne,"NOP4");
  }
  else if ( (codes[1]=='4') && (codes[2]=='0') &&
	    (codes[3]=='0') && (codes[4]=='0')) {
    strcpy(ligne,"NOP5");
    return(5);
  }
  else {
    strcpy(ligne,"GOTO  ");
    champ_rel(addr+1,ligne,&codes[1],3);
  }
  return(4);
}

int desas7(long addr, char *codes,char *ligne)
{
  strcpy(ligne,"GOSUB ");
  champ_rel(addr+4,ligne,&codes[1],3);
  return(4);
}


int desas80(long addr,char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "OUT=CS",  "OUT=C",  "A=IN",  "C=IN",
		     "UNCNFG", "CONFIG", "C=ID",  "SHUTDN",
		     "",       "C+P+1",  "RESET", "BUSCC",
		     "C=P   ", "P=C   ", "SREQ?", "CPEX  " } ;

  if (codes[2]=='8') {
    c=desas808(addr,codes, ligne);
    return(c);
  }
  else {
    c=hextoint(codes[2]);
    strcpy(ligne,mnemo[c]);
    if ( (c==12) || (c==13) || (c==15) ) {
      champ_dec(ligne,codes[3]);
      return(4);
    }
    return(3);
  }
}

int desas808(long addr,char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "INTON",  "RSI",    "LAHEX ",  "BUSCB",
		    "ABIT=0", "ABIT=1", "?ABIT=0", "?ABIT=1",
		    "CBIT=0", "CBIT=1", "?CBIT=0", "?CBIT=1",
		    "PC=(A)", "BUSCD",  "PC=(C)",  "INTOFF" } ;

  c=hextoint(codes[3]);
  strcpy(ligne,mnemo[c]);
  if (c==1) {
    if (codes[4]!='0') strcat(ligne,"???");
    return(5);
  }
  else if (c==2) {
    c=hextoint(codes[4])+1;
    if (c==5) strcpy(ligne,"LA(5) ");
    champ_hex(ligne,&codes[5],c);
    return(c+5);
  }
  else if ( (c>=4) && (c<=11) ) {
    champ_dec(ligne,codes[4]);
    if ( (c==6) || (c==7) || (c==10) || (c==11) ) {
      champ_goyes(addr+5,ligne,&codes[5]);
      return(7);
    }
    else
      return(5);
  }
  else
    return(4);
}


int desas81(char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "ASLC", "BSLC", "CSLC", "DSLC",
		    "ASRC", "BSRC", "CSRC", "DSRC",
		    "", "", "", "",
		    "ASRB", "BSRB", "CSRB", "DSRB" } ;

  switch (codes[2]) {
    case '8' :
      desas818(codes,ligne);
      return(6);
    case '9' :
      desas819(codes,ligne);
      return(5);
    case 'A' :
      desas81A(codes,ligne);
      return(6);
    case 'B' :
      desas81B(codes,ligne);
      return(4);
    default:
      c=hextoint(codes[2]);
      strcpy(ligne,mnemo[c]);
      return(3);
  }
}


int desas818(char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "A=A+", "B=B+", "C=C+", "D=D+",
		    "A=A-", "B=B-", "C=C-", "D=D-" } ;
  c=hextoint(codes[4]);
  if (c&4) {
    strcpy(ligne,"???");
  }
  else {
    if (c>=8) c -=4 ;
    strcpy(ligne,mnemo[c]);
    champ_x1(ligne,codes[5]);
    champ_f(ligne,codes[3]);
  }
  return(6);
}


int desas819(char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "ASRB  ", "BSRB  ", "CSRB  ", "DSRB  " } ;

  if (codes[4]>='4') {
    strcpy(ligne,"???");
  }
  else {
    c=hextoint(codes[4]);
    strcpy(ligne,mnemo[c]);
    champ_f(ligne,codes[3]);
  }
  return(5);
}

int desas81A(char *codes,char *ligne)
{
  int c;
  char *mnemo0[] = { "R0=A  ", "R1=A  ", "R2=A  ", "R3=A  ",
		     "R4=A  ", "R5=A  ", "R6=A  ", "R7=A  ",
		     "R0=C  ", "R1=C  ", "R2=C  ", "R3=C  ",
		     "R4=C  ", "R5=A  ", "R6=A  ", "R7=A  " } ;
  char *mnemo1[] = { "A=R0  ", "A=R1  ", "A=R2  ", "A=R3  ",
		     "A=R4  ", "A=R5  ", "A=R6  ", "A=R7  ",
		     "C=R0  ", "C=R1  ", "C=R2  ", "C=R3  ",
		     "C=R4  ", "C=R5  ", "C=R6  ", "C=R7  " } ;
  char *mnemo2[] = { "AR0EX ", "AR1EX ", "AR2EX ", "AR3EX ",
		     "AR4EX ", "AR5EX ", "AR6EX ", "AR7EX ",
		     "CR0EX ", "CR1EX ", "CR2EX ", "CR3EX ",
		     "CR4EX ", "CR5EX ", "CR6EX ", "CR7EX " } ;

  c=hextoint(codes[5]);
  switch (codes[4]) {
    case '0' :
      strcpy(ligne,mnemo0[c]);
      break;
    case '1' :
      strcpy(ligne,mnemo1[c]);
      break;
    case '2' :
      strcpy(ligne,mnemo2[c]);
      break;
    default :
      strcpy(ligne,"???   ");
  }
  champ_f(ligne,codes[3]);
  return(6);
}

int desas81B(char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "???",  "???",  "PC=A",  "PC=C",
		    "A=PC", "C=PC", "APCEX", "CPCEX" } ;

  c=hextoint(codes[3]);
  if (c>7) {
    strcpy(ligne,"???");
  }
  else {
    strcpy(ligne,mnemo[c]);
  }
  return(4);
}

int desas82(char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "NOP820","XM=0",  "SB=0",  "HBM=0",
		    "SR=0",  "HRM=0", "HRB=0", "HRBM=0",
		    "MP=0",  "HPM=0", "HPB=0", "HPBM=0",
		    "HPR=0", "HPRM=0","HPRB=0","CLRHST" } ;

  c=hextoint(codes[2]);
  strcpy(ligne,mnemo[c]);
  return(3);
}


int desas83(long addr,char *codes,char *ligne)
{
  int c;
  char *mnemo[] = { "?H0=0", "?XM=0",  "?SB=0",  "?HBM=0",
		    "?SR=0", "?HRM=0", "?HRB=0", "?HRBM=0",
		    "?MP=0", "?HPM=0", "?HPB=0", "?HPBM=0",
		    "?HPR=0","?HPRM=0","?HPRB=0","?HPRBM=0" } ;

  c=hextoint(codes[2]);
  strcpy(ligne,mnemo[c]);
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

int desas84(char *codes,char *ligne)
{
  strcpy(ligne,"ST=0  ");
  champ_dec(ligne,codes[2]);
  return(3);
}

int desas85(char *codes,char *ligne)
{
  strcpy(ligne,"ST=1  ");
  champ_dec(ligne,codes[2]);
  return(3);
}

int desas86(long addr,char *codes,char *ligne)
{
  strcpy(ligne,"?ST=0 ");
  champ_dec(ligne,codes[2]);
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

int desas87(long addr,char *codes,char *ligne)
{
  strcpy(ligne,"?ST=1 ");
  champ_dec(ligne,codes[2]);
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

int desas88(long addr,char *codes,char *ligne)
{
  strcpy(ligne,"?P#   ");
  champ_dec(ligne,codes[2]);
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

int desas89(long addr,char *codes,char *ligne)
{
  strcpy(ligne,"?P=   ");
  champ_dec(ligne,codes[2]);
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

void test0(char *ligne,char c)
{
  char *mnemo[] = { "?A=B  ", "?B=C  ", "?C=A  ", "?D=C  ",
		    "?A#B  ", "?B#C  ", "?C#A  ", "?D#C  ",
		    "?A=0  ", "?B=0  ", "?C=0  ", "?D=0  ",
		    "?A#0  ", "?B#0  ", "?C#0  ", "?D#0  " } ;

  c=hextoint(c);
  strcpy(ligne,mnemo[c]);
}

void test1(char *ligne,char c)
{
  char *mnemo[] = { "?A>B  ", "?B>C  ", "?C>A  ", "?D>C  ",
		    "?A<B  ", "?B<C  ", "?C<A  ", "?D<C  ",
		    "?A>=B ", "?B>=C ", "?C>=A ", "?D>=C ",
		    "?A<=B ", "?B<=C ", "?C<=A ", "?D<=C " } ;

  c=hextoint(c);
  strcpy(ligne,mnemo[c]);
}




int desas8A(long addr,char *codes,char *ligne)
{
  test0(ligne,codes[2]);
  strcat(ligne," A");
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

int desas8B(long addr,char *codes,char *ligne)
{
  test1(ligne,codes[2]);
  strcat(ligne," A");
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}

int desas8C(long addr,char *codes,char *ligne)
{
  strcpy(ligne,"GOLONG");
  champ_rel(addr+2,ligne,&codes[2],4);
  return(6);
}

int desas8D(char *codes,char *ligne)
{
  strcpy(ligne,"GOVLNG");
  champ_abs(ligne,&codes[2]);
  return(7);
}

int desas8E(long addr,char *codes,char *ligne)
{
  strcpy(ligne,"GOSUBL");
  champ_rel(addr+6,ligne,&codes[2],4);
  return(6);
}

int desas8F(char *codes,char *ligne)
{
  strcpy(ligne,"GOSBVL");
  champ_abs(ligne,&codes[2]);
  return(7);
}

int desas9(long addr,char *codes,char *ligne)
{
  if (codes[1]<'8') {
    test0(ligne,codes[2]);
    champ_a(ligne,codes[1]);
  }
  else {
    test1(ligne,codes[2]);
    champ_b(ligne,codes[1]);
  }
  champ_goyes(addr+3,ligne,&codes[3]);
  return(5);
}


void tm0(char *ligne,char c)
{
  char *mnemo[] =  { "A=A+B ", "B=B+C ", "C=C+A ", "D=D+C ",
		     "A=A+A ", "B=B+B ", "C=C+C ", "D=D+D ",
		     "B=B+A ", "C=C+B ", "A=A+C ", "C=C+D ",
		     "A=A-1 ", "B=B-1 ", "C=C-1 ", "D=D-1 " } ;
  c=hextoint(c);
  strcpy(ligne,mnemo[c]);
}

void tm1(char *ligne,char c)
{
  char *mnemo[] =  { "A=0   ", "B=0   ", "C=0   ", "D=0   ",
		     "A=B   ", "B=C   ", "C=A   ", "D=C   ",
		     "B=A   ", "C=B   ", "A=C   ", "C=D   ",
		     "ABEX  ", "BCEX  ", "ACEX  ", "CDEX  " } ;
  c=hextoint(c);
  strcpy(ligne,mnemo[c]);
}

void tm2(char *ligne,char c)
{
  char *mnemo[] =  { "A=A-B ", "B=B-C ", "C=C-A ", "D=D-C ",
		     "A=A+1 ", "B=B+1 ", "C=C+1 ", "D=D+1 ",
		     "B=B-A ", "C=C-B ", "A=A-C ", "C=C-D ",
		     "A=B-A ", "B=C-B ", "C=A-C ", "D=C-D " } ;
  c=hextoint(c);
  strcpy(ligne,mnemo[c]);
}

void tm3(char *ligne,char c)
{
  char *mnemo[] =  { "ASL   ", "BSL   ", "CSL   ", "DSL   ",
		     "ASR   ", "BSR   ", "CSR   ", "DSR   ",
		     "A=-A  ", "B=-B  ", "C=-C  ", "D=-D  ",
		     "A=-A-1", "B=-B-1", "C=-C-1", "D=-D-1" } ;
  c=hextoint(c);
  strcpy(ligne,mnemo[c]);
}


int desasA(char *codes,char *ligne)
{
  if (codes[1]<'8') {
    tm0(ligne,codes[2]);
    champ_a(ligne,codes[1]);
  }
  else {
    tm1(ligne,codes[2]);
    champ_b(ligne,codes[1]);
  }
  return(3);
}

int desasB(char *codes,char *ligne)
{
  if (codes[1]<'8') {
    tm2(ligne,codes[2]);
    champ_a(ligne,codes[1]);
  }
  else {
    tm3(ligne,codes[2]);
    champ_b(ligne,codes[1]);
  }
  return(3);
}

int desasC(char *codes,char *ligne)
{
  tm0(ligne,codes[1]);
  strcat(ligne," A");
  return(2);
}

int desasD(char *codes,char *ligne)
{
  tm1(ligne,codes[1]);
  strcat(ligne," A");
  return(2);
}

int desasE(char *codes,char *ligne)
{
  tm2(ligne,codes[1]);
  strcat(ligne," A");
  return(2);
}

int desasF(char *codes,char *ligne)
{
  tm3(ligne,codes[1]);
  strcat(ligne," A");
  return(2);
}


/* module decodage champ desassembleur */


void champ_afb(char *ligne,char c)
{
  char *champ[] = { " P", " WP", " XS", " X", " S", " M", " B", " W" };
  c=hextoint(c)&7;
  strcat(ligne,champ[c]);
}

void champ_a(char *ligne,char c)
{
  if (c<='7')
    champ_afb(ligne,c);
  else
    strcat(ligne," ?");
}


void champ_b(char *ligne,char c)
{
  if (c>='8')
    champ_afb(ligne,c);
  else
    strcat(ligne," ?");
}

void champ_f(char *ligne,char c)
{
  if (c=='F')
    strcat(ligne," A");
  else if (c<='7')
    champ_afb(ligne,c);
  else
    strcat(ligne," ?");
}

void champ_x1(char *ligne,char c)
{
  char s[16];

  c=hextoint(c)+1;
  itoa(c,s,10);
  strupr(s);
  strcat(ligne," ");
  strcat(ligne,s);
}

void champ_dec(char *ligne,char c)
{
  char s[16];

  c=hextoint(c);
  itoa(c,s,10);
  strupr(s);
  strcat(ligne," ");
  strcat(ligne,s);
}

void champ_hex(char *ligne,char *codes,int n)
{
  int i;
  char s[18];
  long a;
  char name[80];

  for (i=0;i<n;i++) {
    s[i]=codes[n-1-i];
  }
  s[n]=0;
  if (n!=5) {
    strcat(ligne," #");
    strcat(ligne,s);
  }
  else {
    sscanf(s,"%lx",&a);
    if ((a>0x200) && ch_label(a,name) ) {
      if (name[0]!='_')
	strcat(ligne," =");
      else
	strcat(ligne," ");
      strcat(ligne,name);
    }
    else {
      strcat(ligne," #");
      strcat(ligne,s);
    }
  }
}


void champ_abs(char *ligne, char *codes)
{
  int i;
  char s[6];
  long a;
  char name[80];

  for (i=0;i<5;i++) {
    s[i]=codes[4-i];
  }
  s[5]=0;
  sscanf(s,"%lx",&a);
  if (ch_label(a,name)) {
    if (name[0]!='_')
      strcat(ligne," =");
    else
      strcat(ligne," ");
    strcat(ligne,name);
  }
  else {
    strcat(ligne," #");
    strcat(ligne,s);
  }
}




void champ_rel(long addr, char *ligne, char *codes, int n)
{
  char s[16];
  int i, a;
  char name[80];

  a=0;
  for (i=n-1;i>=0;i--) {
    a <<= 4;
    a += hextoint(codes[i]);
  }
  if (hextoint(codes[n-1])>=8) {
    switch (n) {
      case 2: a -= 256; break;
      case 3: a -= 4096; break;
    }
  }
  addr = (addr+a) & 0xfffffL;
  if ( from && (n>2) && ch_label(addr,name) ) {
    if (name[0]!='_')
      strcat(ligne," =");
    else
      strcat(ligne," ");
    strcat(ligne,name);
  }
  else {
    sprintf(s," #%05lX",addr);
    strcat(ligne,s);
  }
}


void champ_goyes(long addr, char *ligne, char *codes)
{
  char s[16];
  int a;

  a=(hextoint(codes[1])<<4)+hextoint(codes[0]);
  if (a>127) a -= 256;
  if (a==0) {
    strcat(ligne," / RTNYES");
  }
  else {
    sprintf(s," #%05lX",addr+a);
    strcat(ligne," / GOYES");
    strcat(ligne,s);
  }
}

