; ********************************************************************
;               mulation du processeur Saturn par le 8086
;                       J-F Garnier 1993,95
; --------------------------------------------------------------------
; Module sat_cmp.asm : mulation des instructions de comparaison
; --------------------------------------------------------------------
; Version 1 16/03/93
; Version 1.1 04/11/95 optimisation routage code
;   possibilit d'optimisation des instr. champ a, b, (w)  faire
; ********************************************************************


		; mulation du processeur Saturn par le 8086


; ==================================================================
; dfinitions des instructions de comparaison:
; ?x=y fs
; ?x#y fs
; ?x>y fs
; ?x>=y fs
; ?x<y fs
; ?x<=y fs
; ?x=0 fs
; ?x#0 fs
; ==================================================================





; ******************************************************************
; fonctions de comparaisons
; ******************************************************************


_cmp_p:		call  maj2_w
		xor   ah,ah
		mov   al,_Pointer
		shr   al,1
		jc    _cmp2_p_i
		; paire, quartet infrieur
		add   si,ax
		add   di,ax
		jmp   _cmp_lonib
_cmp2_p_i:      ; impaire, quartet suprieur
		add   si,ax
		add   di,ax
		jmp  _cmp_hinib

_cmp_wp:        call  maj2_w
		xor   ax,ax
		mov   al,_Pointer
		mov   bx,ax
		shr   al,1
		jc    _cmp_wp1
		add   si,ax
		add   di,ax
		call  _cmp_lonib
		jne   _cmp_wp9
		dec   si
		dec   di
		jmp   short _cmp_wp2
_cmp_wp1:	add   si,ax
		add   di,ax
		inc   bx
_cmp_wp2:	jmp   cs:[bx+tab_cmp_wp]
_cmp_wp9:	ret
tab_cmp_wp      dw    _cmp_0
		dw    _cmp_2,  _cmp_4,  _cmp_6,  _cmp_8
		dw    _cmp_10, _cmp_12, _cmp_14, _cmp_16

_cmp_xs:        inc   si
		inc   di
		jmp   _cmp_lonib

_cmp_x:         inc   si
		inc   di
		call  _cmp_lonib
		jne   _cmp_x1
		dec   si
		dec   di
		jmp   _cmp_2
_cmp_x1:        ret

;_cmp_s:		add   si,7
;		add   di,7
;		jmp   _cmp_hinib

_cmp_m:		call  maj2_w
		add   si,7
		add   di,7
		call  _cmp_lonib
		jne   _cmp_m1
		dec   si
		dec   di
		jmp   _cmp_11
_cmp_m1:        ret

;_cmp_w:
;               call  maj2_w
;               call  _cmp_16
;               ret

cmp_byte        macro
		mov  al,[si]
		cmp  [di],al
		jne  _cmp_end
		dec  si
		dec  di
		endm

_cmp_lonib:	mov  al,[si]
		mov  ah,[di]
		and  ax,0f0fh
		cmp  ah,al
		ret

_cmp_16:        cmp_byte
_cmp_14:        cmp_byte
_cmp_12:        cmp_byte
_cmp_10:        cmp_byte
_cmp_8:         cmp_byte
_cmp_6:         cmp_byte
_cmp_4:         cmp_byte
_cmp_2:         mov  al,[si]
		cmp  [di],al
_cmp_end:       ret
_cmp_0:		xor  ax,ax   ; Z=1
		ret


_cmp_15:        cmp_byte
_cmp_13:        cmp_byte
_cmp_11:        cmp_byte
_cmp_9:         cmp_byte
_cmp_7:         cmp_byte
_cmp_5:         cmp_byte
_cmp_3:         cmp_byte
_cmp_1:
_cmp_hinib:     mov  al,[si]
		mov  ah,[di]
		and  ax,0f0f0h
		cmp  ah,al
		ret

_cmp_a          macro
                local _cmp_a1
                mov  al,[bx-1]
		mov  ah,[di-1]
		and  ax,0f0fh
		cmp  ah,al
		jne  _cmp_a1
		mov  ax,[bx]
		cmp  [di],ax
_cmp_a1:
                endm

_cmp_b          macro
                mov  al,[bx]
		cmp  [di],al
		endm

_cmp_w:         mov  ax,[si+6]
		cmp  [di+6],ax
		jne  _cmp_w1
		mov  ax,[si+4]
		cmp  [di+4],ax
		jne  _cmp_w1
		call maj2_w        ; !!
		mov  ax,[si+2]
		cmp  [di+2],ax
		jne  _cmp_w1
		mov  ax,[si]
		cmp  [di],ax
_cmp_w1:        ret

_cmp_s          macro
		mov  al,[bx+7]
		mov  ah,[di+7]
		and  ax,0f0f0h
		cmp  ah,al
		endm


; ==============================================================

		align 2
condition_vrai:
		set_carry
                incr_pc
		mov   ax,es:[si]
		sar   ax,cl
		or    al,al
		je    cond_vrai2
		cbw
		jmp   dojump
cond_vrai2:     jmp   _rtn

; ==============================================================


; code d'excution d'instructions de comparaison de 2 arguments


		align 2
_eq_A_B_a:      exec_opcode2s _eq2 A B a
_eq_B_C_a:      exec_opcode2s _eq2 B C a
_eq_C_A_a:      exec_opcode2s _eq2 C A a
_eq_D_C_a:      exec_opcode2s _eq2 D C a

_eq2_a:         _cmp_a
		jne   faux_eq2
		jmp   condition_vrai

		align 2
_eq_A_B_b:      exec_opcode2s _eq2 A B b
_eq_B_C_b:      exec_opcode2s _eq2 B C b
_eq_C_A_b:      exec_opcode2s _eq2 C A b
_eq_D_C_b:      exec_opcode2s _eq2 D C b

_eq2_b:         _cmp_b
		jne   faux_eq2
		jmp   condition_vrai

		align 2
_eq_A_B_s:      exec_opcode2s _eq2 A B s
_eq_B_C_s:      exec_opcode2s _eq2 B C s
_eq_C_A_s:      exec_opcode2s _eq2 C A s
_eq_D_C_s:      exec_opcode2s _eq2 D C s

_eq2_s:         _cmp_s
		jne   faux_eq2
		jmp   condition_vrai

faux_eq2:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI


		irp   CHAMP,<p, wp, xs, x, m, w>
		local faux
_eq2_&CHAMP&:   call  _cmp_&CHAMP&
		pop   si
		jne   faux_eq2
		jmp   condition_vrai
		endm


                align 2
_ne_A_B_a:      exec_opcode2s _ne2 A B a
_ne_B_C_a:      exec_opcode2s _ne2 B C a
_ne_C_A_a:      exec_opcode2s _ne2 C A a
_ne_D_C_a:      exec_opcode2s _ne2 D C a

_ne2_a:         _cmp_a
		je    faux_ne2
		jmp   condition_vrai

                align 2
_ne_A_B_b:      exec_opcode2s _ne2 A B b
_ne_B_C_b:      exec_opcode2s _ne2 B C b
_ne_C_A_b:      exec_opcode2s _ne2 C A b
_ne_D_C_b:      exec_opcode2s _ne2 D C b

_ne2_b:         _cmp_b
		je    faux_ne2
		jmp   condition_vrai

                align 2
_ne_A_B_s:      exec_opcode2s _ne2 A B s
_ne_B_C_s:      exec_opcode2s _ne2 B C s
_ne_C_A_s:      exec_opcode2s _ne2 C A s
_ne_D_C_s:      exec_opcode2s _ne2 D C s

_ne2_s:         _cmp_s
		je    faux_ne2
		jmp   condition_vrai

faux_ne2:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI


		irp   CHAMP,<p, wp, xs, x, m, w>
		local faux
_ne2_&CHAMP&:   call  _cmp_&CHAMP&
		pop   si
		je    faux_ne2
		jmp   condition_vrai
		endm


                align 2
_gt_A_B_a:      exec_opcode2s _gt2 A B a
_gt_B_C_a:      exec_opcode2s _gt2 B C a
_gt_C_A_a:      exec_opcode2s _gt2 C A a
_gt_D_C_a:      exec_opcode2s _gt2 D C a
_gt_B_A_a:      exec_opcode2s _gt2 B A a
_gt_C_B_a:      exec_opcode2s _gt2 C B a
_gt_A_C_a:      exec_opcode2s _gt2 A C a
_gt_C_D_a:      exec_opcode2s _gt2 C D a

_gt2_a:         _cmp_a
		jbe   faux_gt2a
		jmp   condition_vrai
faux_gt2a:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI

                align 2
_gt_A_B_b:      exec_opcode2s _gt2 A B b
_gt_B_C_b:      exec_opcode2s _gt2 B C b
_gt_C_A_b:      exec_opcode2s _gt2 C A b
_gt_D_C_b:      exec_opcode2s _gt2 D C b
_gt_B_A_b:      exec_opcode2s _gt2 B A b
_gt_C_B_b:      exec_opcode2s _gt2 C B b
_gt_A_C_b:      exec_opcode2s _gt2 A C b
_gt_C_D_b:      exec_opcode2s _gt2 C D b

_gt2_b:         _cmp_b
		jbe   faux_gt2b
		jmp   condition_vrai
faux_gt2b:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI

                align 2
_gt_A_B_s:      exec_opcode2s _gt2 A B s
_gt_B_C_s:      exec_opcode2s _gt2 B C s
_gt_C_A_s:      exec_opcode2s _gt2 C A s
_gt_D_C_s:      exec_opcode2s _gt2 D C s
_gt_B_A_s:      exec_opcode2s _gt2 B A s
_gt_C_B_s:      exec_opcode2s _gt2 C B s
_gt_A_C_s:      exec_opcode2s _gt2 A C s
_gt_C_D_s:      exec_opcode2s _gt2 C D s

_gt2_s:         _cmp_s
		jbe   faux_gt2s
		jmp   condition_vrai
faux_gt2s:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI

		irp   CHAMP,<p, wp, xs, x, m, w>
		local faux
_gt2_&CHAMP&:   call  _cmp_&CHAMP&
		pop   si
		jbe   faux_gt2
		jmp   condition_vrai
		endm
faux_gt2:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI


                align 2
_ge_A_B_a:      exec_opcode2s _ge2 A B a
_ge_B_C_a:      exec_opcode2s _ge2 B C a
_ge_C_A_a:      exec_opcode2s _ge2 C A a
_ge_D_C_a:      exec_opcode2s _ge2 D C a
_ge_B_A_a:      exec_opcode2s _ge2 B A a
_ge_C_B_a:      exec_opcode2s _ge2 C B a
_ge_A_C_a:      exec_opcode2s _ge2 A C a
_ge_C_D_a:      exec_opcode2s _ge2 C D a

_ge2_a:         _cmp_a
		jb    faux_ge2a
		jmp   condition_vrai
faux_ge2a:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI

                align 2
_ge_A_B_b:      exec_opcode2s _ge2 A B b
_ge_B_C_b:      exec_opcode2s _ge2 B C b
_ge_C_A_b:      exec_opcode2s _ge2 C A b
_ge_D_C_b:      exec_opcode2s _ge2 D C b
_ge_B_A_b:      exec_opcode2s _ge2 B A b
_ge_C_B_b:      exec_opcode2s _ge2 C B b
_ge_A_C_b:      exec_opcode2s _ge2 A C b
_ge_C_D_b:      exec_opcode2s _ge2 C D b

_ge2_b:         _cmp_b
		jb    faux_ge2b
		jmp   condition_vrai
faux_ge2b:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI

                align 2
_ge_A_B_s:      exec_opcode2s _ge2 A B s
_ge_B_C_s:      exec_opcode2s _ge2 B C s
_ge_C_A_s:      exec_opcode2s _ge2 C A s
_ge_D_C_s:      exec_opcode2s _ge2 D C s
_ge_B_A_s:      exec_opcode2s _ge2 B A s
_ge_C_B_s:      exec_opcode2s _ge2 C B s
_ge_A_C_s:      exec_opcode2s _ge2 A C s
_ge_C_D_s:      exec_opcode2s _ge2 C D s

_ge2_s:         _cmp_s
		jb    faux_ge2s
		jmp   condition_vrai
faux_ge2s:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI


		irp   CHAMP,<p, wp, xs, x, m, w>
		local faux
_ge2_&CHAMP&:   call  _cmp_&CHAMP&
		pop   si
		jb    faux_ge2
		jmp   condition_vrai
		endm
faux_ge2:       ; condition_fausse
		clear_carry
		inc   si
		NEXTI







; **************************************************************
;               eq2
; **************************************************************
; fonctions de comparaison


; dfinitions des points d'entres
		align 2
		irp   CHAMP,<p, wp, xs, x, m, w>

_eq_A_B_&CHAMP&:     exec_opcode2 _eq2 A B CHAMP
_eq_B_C_&CHAMP&:     exec_opcode2 _eq2 B C CHAMP
_eq_C_A_&CHAMP&:     exec_opcode2 _eq2 C A CHAMP
_eq_D_C_&CHAMP&:     exec_opcode2 _eq2 D C CHAMP

		endm


; **************************************************************
;               ne2
; **************************************************************
; fonctions de comparaison


; dfinitions des points d'entres
		irp   CHAMP,<p, wp, xs, x, m, w>

_ne_A_B_&CHAMP&:     exec_opcode2 _ne2 A B CHAMP
_ne_B_C_&CHAMP&:     exec_opcode2 _ne2 B C CHAMP
_ne_C_A_&CHAMP&:     exec_opcode2 _ne2 C A CHAMP
_ne_D_C_&CHAMP&:     exec_opcode2 _ne2 D C CHAMP

		endm



; **************************************************************
;               gt2
; **************************************************************
; fonctions de comparaison


; dfinitions des points d'entres
		irp   CHAMP,<p, wp, xs, x, m, w>

_gt_A_B_&CHAMP&:     exec_opcode2 _gt2 A B CHAMP
_gt_B_C_&CHAMP&:     exec_opcode2 _gt2 B C CHAMP
_gt_C_A_&CHAMP&:     exec_opcode2 _gt2 C A CHAMP
_gt_D_C_&CHAMP&:     exec_opcode2 _gt2 D C CHAMP
_gt_B_A_&CHAMP&:     exec_opcode2 _gt2 B A CHAMP
_gt_C_B_&CHAMP&:     exec_opcode2 _gt2 C B CHAMP
_gt_A_C_&CHAMP&:     exec_opcode2 _gt2 A C CHAMP
_gt_C_D_&CHAMP&:     exec_opcode2 _gt2 C D CHAMP

		endm


; **************************************************************
;               ge2
; **************************************************************
; fonctions de comparaison


; dfinitions des points d'entres
		irp   CHAMP,<p, wp, xs, x, m, w>

_ge_A_B_&CHAMP&:     exec_opcode2 _ge2 A B CHAMP
_ge_B_C_&CHAMP&:     exec_opcode2 _ge2 B C CHAMP
_ge_C_A_&CHAMP&:     exec_opcode2 _ge2 C A CHAMP
_ge_D_C_&CHAMP&:     exec_opcode2 _ge2 D C CHAMP
_ge_B_A_&CHAMP&:     exec_opcode2 _ge2 B A CHAMP
_ge_C_B_&CHAMP&:     exec_opcode2 _ge2 C B CHAMP
_ge_A_C_&CHAMP&:     exec_opcode2 _ge2 A C CHAMP
_ge_C_D_&CHAMP&:     exec_opcode2 _ge2 C D CHAMP

		endm







; ******************************************************************
; fonctions de test
; ******************************************************************




_tst_p:
		call  maj_w
		xor   ah,ah
		mov   al,_Pointer
		shr   al,1
		jc    _tst_p_i
		; paire, quartet infrieur
		add   di,ax
		jmp   _tst_lonib
_tst_p_i:       ; impaire, quartet suprieur
		add   di,ax
		jmp   _tst_hinib

_tst_wp:	call  maj_w
		xor   ax,ax
		mov   al,_Pointer
		mov   bx,ax
		shr   al,1
		jc    _tst_wp1
		add   di,ax
		call  _tst_lonib
		jne   _tst_wp9
		dec   di
		jmp   short _tst_wp2
_tst_wp1:	add   di,ax
		inc   bx
_tst_wp2:	jmp   cs:[bx+tab_tst_wp]
_tst_wp9:	ret
tab_tst_wp      dw    _tst_0
		dw    _tst_2,  _tst_4,  _tst_6,  _tst_8
		dw    _tst_10, _tst_12, _tst_14, _tst_16

_tst_xs:	inc   di
		jmp   _tst_lonib

_tst_x:         inc   di
		call  _tst_lonib
		jne   _tst_x1
		dec   di
		jmp   _tst_2
_tst_x1:        ret

;_tst_s:		add   di,7
;		jmp   _tst_hinib

_tst_m:		call  maj_w
		add   di,7
		call  _tst_lonib
		jne   _tst_m1
		dec   di
		jmp   _tst_11
_tst_m1:        ret

;_tst_w:	call  maj_w
;		add   di,7
;		jmp   _tst_16





tst_byte        macro
		mov  al,[di]
		or   al,al
		jne  _tst_end
		dec  di
		endm

_tst_lonib:	mov  al,[di]
		and  al,0fh
		ret

_tst_16:        tst_byte
_tst_14:        tst_byte
_tst_12:        tst_byte
_tst_10:        tst_byte
_tst_8:         tst_byte
_tst_6:         tst_byte
_tst_4:         tst_byte
_tst_2:         mov  al,[di]
		or   al,al
_tst_end:       ret
_tst_0:		xor  ax,ax   ; Z=1
		ret

_tst_15:        tst_byte
_tst_13:        tst_byte
_tst_11:        tst_byte
_tst_9:         tst_byte
_tst_7:         tst_byte
_tst_5:         tst_byte
_tst_3:         tst_byte
_tst_1:
_tst_hinib:	mov  al,[di]
		and  al,0f0h
		ret


_tst_a          macro
                local _tst_a1
                mov  al,[di-1]
;		and  al,0fh
;		jne  _tst_a1
;		mov  ax,[di]
;		or   ax,ax
		and  ax,0fh        ; changed JFG, 20/07/07 in Arlington Hts, IL
		or   ax,[di]

_tst_a1:
                endm


_tst_b          macro
                mov  al,[di]
		or   al,al
		endm

_tst_w:		mov  ax,[di+6]
		or   ax,ax
		jne  _tst_w1
		mov  ax,[di+4]
		or   ax,ax
		jne  _tst_w1
		call maj_w           ; !!!
		mov  ax,[di+2]
		or   ax,ax
		jne  _tst_w1
		mov  ax,[di]
		or   ax,ax
_tst_w1:	ret

_tst_s          macro
		mov  al,[di+7]
		and  al,0f0h
		endm

                align 2
_eq_A_a:        exec_opcode1s _eq A a
_eq_B_a:        exec_opcode1s _eq B a
_eq_D_a:        exec_opcode1s _eq D a
_eq_C_a:        mov   di, offset _regC

_eq_a:          _tst_a
		jne   faux_eq
		jmp   condition_vrai

                align 2
_eq_A_b:        exec_opcode1s _eq A b
_eq_B_b:        exec_opcode1s _eq B b
_eq_D_b:        exec_opcode1s _eq D b
_eq_C_b:        mov   di, offset _regC

_eq_b:          _tst_b
		jne   faux_eq
		jmp   condition_vrai

                align 2
_eq_A_s:        exec_opcode1s _eq A s
_eq_B_s:        exec_opcode1s _eq B s
_eq_D_s:        exec_opcode1s _eq D s
_eq_C_s:        mov   di, offset _regC

_eq_s:          _tst_s
		jne   faux_eq
		jmp   condition_vrai

faux_eq:        ; condition_fausse
		clear_carry
		inc   si
		NEXTI

		align 2
		irp   CHAMP,<p, wp, xs, x, m, w>
		local  faux
_eq_&CHAMP&:    call  _tst_&CHAMP&
		jne   faux_eq
		jmp   condition_vrai
		endm


                align 2
_ne_A_a:        exec_opcode1s _ne A a
_ne_B_a:        exec_opcode1s _ne B a
_ne_D_a:        exec_opcode1s _ne D a
_ne_C_a:        mov   di, offset _regC

_ne_a:          _tst_a
		je    faux_ne
		jmp   condition_vrai

                align 2
_ne_A_b:        exec_opcode1s _ne A b
_ne_B_b:        exec_opcode1s _ne B b
_ne_D_b:        exec_opcode1s _ne D b
_ne_C_b:        mov   di, offset _regC

_ne_b:          _tst_b
		je    faux_ne
		jmp   condition_vrai

                align 2
_ne_A_s:        exec_opcode1s _ne A s
_ne_B_s:        exec_opcode1s _ne B s
_ne_D_s:        exec_opcode1s _ne D s
_ne_C_s:        mov   di, offset _regC

_ne_s:          _tst_s
		je    faux_ne
		jmp   condition_vrai

faux_ne:        ; condition_fausse
		clear_carry
		inc   si
		NEXTI

		align 2
		irp   CHAMP,<p, wp, xs, x, m, w>
		local  faux
_ne_&CHAMP&:    call  _tst_&CHAMP&
		je    faux_ne
		jmp   condition_vrai
		endm





; **************************************************************
;               eq
; **************************************************************
; fonctions de test


; dfinitions des points d'entres
		align 2
		irp   CHAMP,<p, wp, xs, x, m, w>

_eq_A_&CHAMP&:     exec_opcode _eq A CHAMP
_eq_B_&CHAMP&:     exec_opcode _eq B CHAMP
_eq_C_&CHAMP&:     exec_opcode _eq C CHAMP
_eq_D_&CHAMP&:     exec_opcode _eq D CHAMP

		endm


; **************************************************************
;               ne
; **************************************************************
; fonctions de test

; dfinitions des points d'entres
		irp   CHAMP,<p, wp, xs, x, m, w>

_ne_A_&CHAMP&:     exec_opcode _ne A CHAMP
_ne_B_&CHAMP&:     exec_opcode _ne B CHAMP
_ne_C_&CHAMP&:     exec_opcode _ne C CHAMP
_ne_D_&CHAMP&:     exec_opcode _ne D CHAMP

		endm


