; ********************************************************************
;               mulation du processeur Saturn par le 8086
;                       J-F Garnier 1993
; --------------------------------------------------------------------
; Module sat_ctrl.asm : mulation des instructions de controle
; --------------------------------------------------------------------
; Version 1.0 04/09/93
;   prototype
; Version 1.1 04/11/95
; Version 2 09/09/01 add some systems opcodes, and bit op for HP42S support
; ********************************************************************



; ------------------------------------------------
; modes decimal, binaire
; ------------------------------------------------

_sethex:        clr_decimal
		NEXT

_setdec:        set_decimal
		NEXT

; ------------------------------------------------
; pile
; ------------------------------------------------

_oldrstk_c:        ; construit bx pointant dans pile retour
		mov  al,_retstkptr
		dec  al
		and  ax,7
		mov  _retstkptr,al
		sal  ax,2
		add  ax,offset _retstk
		mov  bx,ax
                ;
		mov  ax,word ptr _regC
		mov  [bx],ax
		mov  al,_regC-1
		mov  [bx+2],al
		NEXT


_rstk_c:       ; construit bx pointant dans pile retour
		mov  al,_retstkptr
		sub  al,4
		mov  _retstkptr,al
                xor  ah,ah
                add  ax,offset _retstk
                xchg ax,bx
                ;
		mov  ax,word ptr _regC
		mov  [bx],ax
		mov  al,_regC-1
                and  al,0fh
		mov  [bx+2],al
		NEXT



_oldc_rstk:
		mov  al,_retstkptr
		xor  bh,bh
		mov  bl,al
		inc  al
		and  al,7
		mov  _retstkptr,al
		sal  bx,2
		add  bx, offset _retstk
		mov  ax,[bx]
		mov  word ptr _regC,ax
		mov  al,[bx+2]
		mov  _regC-1,al
		; remet  zro le niveau suprieur de la pile
		xor  ax,ax
		mov  [bx],ax
		mov  [bx+2],ax
		NEXT

_c_rstk:
		mov  al,_retstkptr
                mov  bl,al
                xor  ah,ah
                add  ax,offset _retstk
                xchg ax,bx
		add  al,4
		mov  _retstkptr,al
                ;
                xor  ax,ax
		xchg ax,[bx]
		mov  word ptr _regC,ax
                xor  al,al
		xchg  al,[bx+2]
		mov  _regC-1,al
                ;
		NEXT

; ------------------------------------------------
; LCHEX, LAHEX
; ------------------------------------------------


_lahex:         fetch_nib
                mov  di,offset _regA
		test_pointer
		jne  loadhex0
		; P=0
		or  al,al
		jne  load0hex2
		; lc(1)
		fetch_nib
                mov  ah,[di]
                and  ah,0f0h
                or   al,ah
		mov  [di],al
		NEXT
load0hex2:	cmp  al,1
		jne  load0hex5
		; lc(2)
		fetch_byte
		mov  [di],al
		NEXT
load0hex5:      cmp  al,4
		jne  load0hex4
		; lc(5)
		fetch_byte
		mov  [di],al
		fetch_3nib
		mov  [di+1],al
		mov  [di-1],ah
                set_majw
		NEXT
load0hex4:      cmp  al,3
                jne  loadhex0
		; lc(4)
		fetch_byte
		mov  [di],al
		fetch_byte
		mov  [di+1],al
		NEXT
loadhex0:       jmp  loadhex


; LC(1) ax=-x03
                align 2
_lchex1:        test_pointer
                jne  _lchex1x
                mov  al,_regC
                and  al,0f0h
                or   al,ah
                mov  _regC,al
                NEXTI
_lchex1x:       xor  bx,bx
                mov  bl,_Pointer
                shr  bl,1
                jnc  _lchex1c
                add  bx,offset _regC
                mov  al,[bx]
                and  al,0fh
                shl  ah,4
                or   al,ah
                mov  [bx],al
                NEXTI
_lchex1c:       cmp  bl,2
                je   _lchex14
                add  bx,offset _regC
                mov  al,[bx]
                and  al,0f0h
                or   al,ah
                mov  [bx],al
                NEXTI
_lchex14:       ; load 1 nibble in C[4]
                mov  _regC-1,ah
                set_majw
                NEXTI



; LC(3) ax=-x23
_lchex3:        test_pointer
                jne  _lchex44
                mov  di, offset _regC
		fetch_byte
                mov  [di],al
                mov  al,[di+1]
                and  ax,0ff0h
                or   al,ah
                mov  [di+1],al
                NEXTI

; LC(6) ax=-x53
_lchex6:        test_pointer
                jne  _lchex44
                mov  di, offset _regC
		fetch_byte
                mov  [di],al
		fetch_byte
                mov  [di+1],al
		fetch_byte
                mov  [di+2],al
                mov  [di-1],al
                clr_majw
                NEXT

; LC(4) ax=-x33
_lchex4:        test_pointer
_lchex44:       jne  _lchex
                mov  di, offset _regC
		fetch_byte
                mov  [di],al
		fetch_byte
                mov  [di+1],al
                NEXT


; LC(5) ax=-x43
                align 2
_lchex5:        test_pointer
                jne  _lchex
                mov  di, offset _regC
		fetch_byte
                mov  [di],al
		fetch_byte
                mov  [di+1],al
                mov  [di-1],ah
                set_majw
                NEXTI


; LC(2) ax=-x13
                align 2
_lchex2:        test_pointer
_lchex40:       jne  _lchex
		fetch_byte
                mov  _regC,al
                NEXT


                align 2
_lchex:         ; charge C  partir de la position P pour n+1 quartets
		; al[7-4] contient n
                shr  al,4
		mov  di,offset _regC

loadhex:        ; cas gnral
		; si P impaire:
		;   fetch_nib  --> hinib
		;   n--
		;   p++; si P>15 p=0
		; tant que n>0
		;   fetch_byte
		;   n-=2
		;   p+=2; si p>15 p=0
		; si n=0
		;   fetch_nib  --> lonib
		mov  dl,al        ; dl : n
		call maj_w
		push di
		xor  ax,ax
		mov  al,_Pointer
		mov  dh,al        ; dh : P
		shr  al,1
		add  di,ax        ; di = pointeur dans reg
		test dh,1
		je   loadhex1
		fetch_nib
		shl  al,4
		mov  ah,[di]
		and  ax,00ff0h
		or   al,ah
		mov  [di],al
		dec  dl
		js   loadhex9
		inc  di
		inc  dh
		cmp  dh,16
		jne  loadhex1
		sub  di,8
loadhex1:       or   dl,dl
		js   loadhex9
		je   loadhex2
		fetch_byte
		mov  [di],al
		inc  di
		dec  dl
		dec  dl
		inc  dh
		inc  dh
		cmp  dh,16
		jne  loadhex1
		sub  di,8
		jmp  loadhex1
loadhex2:       fetch_nib
		mov  ah,[di]
		and  ax,0f00fh
		or   al,ah
		mov  [di],al
loadhex9:       pop  di
		maj_a
		NEXT

; ------------------------------------------------
; registre status
; ------------------------------------------------

_clrst:         and  _status,0f000h
		NEXT
_c_st:          mov  ax,_status
		mov  _regC,al
		mov  al,_regC+1
		and  ax,00ff0h
		or   al,ah
		mov  _regC+1,al
		NEXT
_st_c:          mov  ax,word ptr _regC
		mov  byte ptr _status,al
		mov  al,byte ptr _status+1
		and  ax,00ff0h
		or   al,ah
		mov  byte ptr _status+1,al
		NEXT
_cstex:         mov  al,_regC
		xchg al,byte ptr _status
		mov  _regC,al
		mov  al,byte ptr _regC+1
		mov  ah,byte ptr _status+1
		mov  bx,ax
		and  ax,0f00fh
		or   al,ah
		mov  byte ptr _status+1,al
		mov  ax,bx
		and  ax,00ff0h
		or   al,ah
		mov  _regC+1,al
		NEXT

_clr_st:        ; ah = mask
		mov  bl,cl
		mov  cl,ah
		mov  ax,1
		sal  ax,cl
		mov  cl,bl
		not  ax
		and  _status,ax
		NEXTI

_set_st:
		mov  bl,cl
		mov  cl,ah
		mov  ax,1
		sal  ax,cl
		mov  cl,bl
		or   _status,ax
		NEXTI

_tst_st0:       incr_pc
		mov  bl,cl
		mov  cl,ah
		mov  ax,1
		sal  ax,cl
		mov  cl,bl
		and  ax,_status
		je   _tst_stx
		clear_carry
		inc  si
		NEXT

_tst_st1:       incr_pc
		mov  bl,cl
		mov  cl,ah
		mov  ax,1
		sal  ax,cl
		mov  cl,bl
		and  ax,_status
		jne  _tst_stx
		clear_carry
		inc  si
		NEXT

; ------------------------------------------------
; hardware status
; ------------------------------------------------

_clrhst:        mov  al,ah
		not  al
		and  _hwstatus,al
		NEXTI

_tsthst:
                incr_pc
                mov  al,ah
		and  al,_hwstatus
		je   _tst_stx
		clear_carry
		inc  si
		NEXT
_tst_stx:       set_carry
		mov  ax,es:[si]
		sar  ax,cl
		or   al,al
		je   _tst_stx1
		cbw
		jmp  dojump
_tst_stx1:	jmp  _rtn

; ------------------------------------------------
; pointer P
; ------------------------------------------------


_tst_p0:        ; test si P # n ?
		incr_pc
		cmp  ah,_Pointer
		jne  _tst_stx
		clear_carry
		inc  si
		NEXT

_tst_p1:        ; test si P = n ?
		incr_pc
		cmp  ah,_Pointer
		je   _tst_stx
		clear_carry
		inc  si
		NEXT

_incr_p:        mov  al,_Pointer
		add  al,1
		update_halfcarry
		and  al,15
		mov  _Pointer,al
                je   _p_00
                set_pointer
		NEXT

_decr_p:        mov  al,_Pointer
		sub  al,1
		update_halfcarry
		and  al,15
		mov  _Pointer,al
                je   _p_00
                set_pointer
		NEXT


_p_0:           mov  _Pointer,0
_p_00:          clr_pointer
                NEXT

_p_x:           shr  al,4
		mov  _Pointer,al
                set_pointer
		NEXT



_add_C_P_1:     ; C(A)=C+P+1
		mov  al,_Pointer
		inc  al
		xor  ah,ah
		add  word ptr _regC,ax
		adc  _regC-1,0
		update_halfcarry
		NEXTI

_mov_C_P_n:     ; C=P  n
		mov  di,offset _regC
                fetch_byte
                shr  al,5
		jc   _mov_c_p_i
		; paire, quartet infrieur
                cmp  al,2
                je   _mov_c_p_4
                cbw
		add  di,ax
		mov  al,[di]
		and  al,0f0h
		or   al,_Pointer
                mov  [di],al
		NEXT
_mov_c_p_i:     ; impaire, quartet suprieur
                cbw
		add  di,ax
		mov  al,[di]
		and  al,00fh
		mov  ah,_Pointer
		sal  ah,4
		or   al,ah
                mov  [di],al
		NEXT
_mov_c_p_4:     mov  al, _Pointer
                mov  [di-1],al
                NEXT


_mov_P_C_n:     ; P=C  n
                fetch_byte
                shr  al,4
                mov  bl,al
		mov  di,offset _regC
		call maj_w
		mov  al,bl
		and  ax,15
		shr  al,1
		jc   _mov_p_c_i
		; paire, quartet infrieur
		add  di,ax
		mov  al,[di]
		jmp  short _mov_p_c_x
_mov_p_c_i:     ; impaire, quartet suprieur
		add  di,ax
		mov  al,[di]
		sar  al,4
_mov_p_c_x:     and  al,00fh
		mov  _Pointer,al
                set_pointer
		NEXT

_xch_C_P_n:     fetch_byte
                shr  al,4
                mov  bl,al
		mov  di,offset _regC
                push di
		call maj_w
		mov  al,bl
		and  ax,15
		shr  al,1
		jc   _xch_c_p_i
		; paire, quartet infrieur
		add  di,ax
		mov  al,[di]
		mov  ah,al
		and  ax,00ff0h
		or   al,_Pointer
		jmp  short _xch_c_p_x
_xch_c_p_i:     ; impaire, quartet suprieur
		add  di,ax
		mov  al,[di]
		ror  al,4
		mov  ah,al
		and  ax,00ff0h
		or   al,_Pointer
		rol  al,4
_xch_c_p_x:     mov  _Pointer,ah
		mov  [di],al
                pop  di
		maj_a
                set_pointer
		NEXT

; ------------------------------------------------
; registres input/output
; ------------------------------------------------

_mov_OUT_C:     mov  ax,word ptr _regC
		and  ax,00fffh
		mov  _output,ax
		NEXTI
_mov_OUT_CS:    mov  al,_regC
		mov  ah,byte ptr _output
		and  ax,0f00fh
		or   al,ah
		mov  byte ptr _output,al
		NEXTI
_mov_A_IN:      mov  ax,_input
		mov  word ptr _regA,ax
		NEXTI
_mov_C_IN:      mov  ax,_input
		mov  word ptr _regC,ax
		NEXTI

; ------------------------------------------------
; instructions systme
; ------------------------------------------------

chktimer:
                mov  bx,es
                mov  ax,word ptr [_tab_seg+4]
                mov  es,ax

                mov  di,070feh
                mov  ax,es:[di]
                and  al,ah
                and  al,080h
                jne  chtim1

                add  di,080h
                mov  ax,es:[di]
                and  al,ah
                and  al,080h
                jne  chtim1

                add  di,080h
                mov  ax,es:[di]
                and  al,ah
                and  al,080h
;                jne  chtim1

chtim1:         mov  es,bx
                ret



_uncnfg:        mov  ax,1
		jmp  retouri
_config:        mov  ax,2
		jmp  retouri
_mov_C_ID:      mov  ax,3
		jmp  retouri
_shutdn:        mov  ax,4
		jmp  retouri
_reset:         mov  ax,5
		jmp  retouri
_buscc:         mov  ax,6
		jmp  retouri

_buscb:
_buscd:         mov  ax,6
		jmp  retour

_sreq:
;                mov  ax,7
;		jmp  retouri
		and  _regC,0f0h
                call chktimer
                or   al,al
		je   sreq1
		or   _regC,1
		or   _hwstatus,4      ; SR
;		mov  _timer_to,0
sreq1:		NEXTI

; (code 8 = RTNSXM)

; added 25/03/06:
_rsi:           ; RSI is 80810
                fetch_nib
_inton:
_intoff:
                NEXT




; ------------------------------------------------
; bit operations on A and C
; ------------------------------------------------

_clrb_A_n:      mov  di, offset _regA
                jmp  short _clrbit_n
_clrb_C_n:      mov  di, offset _regC
_clrbit_n:      fetch_nib
                mov  dx,1
                xchg al,cl
                shl  dx,cl
                mov  cl,al
                not  dx
                and  [di],dx
                NEXT


_setb_A_n:      mov  di, offset _regA
                jmp  short _setbit_n
_setb_C_n:      mov  di, offset _regC
_setbit_n:      fetch_nib
                mov  dx,1
                xchg al,cl
                shl  dx,cl
                mov  cl,al
                or   [di],dx
                NEXT


_isset_A_n:     mov  di, offset _regA
                jmp  short _issetbit_n
_isset_C_n:     mov  di, offset _regC
_issetbit_n:    fetch_nib
                mov  dx,1
                xchg al,cl
                shl  dx,cl
                mov  cl,al
                and  dx,[di]
                je   _isset2
		jmp  _tst_stx
_isset2:        clear_carry
                inc  si
                NEXT


_isclr_A_n:     mov  di, offset _regA
                jmp  short _isclrbit_n
_isclr_C_n:     mov  di, offset _regC
_isclrbit_n:    fetch_nib
                mov  dx,1
                xchg al,cl
                shl  dx,cl
                mov  cl,al
                and  dx,[di]
                jne  _isset2
		jmp  _tst_stx




; ------------------------------------------------
; registres D0, D1
; ------------------------------------------------

_ld_D0_2:       fetch_byte
		mov  _regD0,al
		NEXT
_ld_D0_4:       fetch_byte
		mov  _regD0,al
		fetch_byte
		mov  _regD0+1,al
		NEXT
_ld_D0_5:       fetch_byte
		mov  _regD0,al
		fetch_byte
                and  ah,0fh
		mov  word ptr _regD0+1,ax
		NEXTI
_ld_D1_2:       fetch_byte
		mov  _regD1,al
		NEXT
_ld_D1_4:       fetch_byte
		mov  _regD1,al
		fetch_byte
		mov  _regD1+1,al
		NEXT
_ld_D1_5:       fetch_byte
		mov  _regD1,al
		fetch_byte
                and  ah,0fh
		mov  word ptr _regD1+1,ax
		NEXTI

; inc Dx, dec Dx : ax = [ - n x x ]
_inc_D0:	mov  al,ah
		inc  al
                cbw
                add  word ptr _regD0,ax
                jc   _inc_D0x
		clear_carry
		NEXTI
_inc_D0x:	adc  _regD0+2,0
		update_halfcarry
		NEXTI

_inc_D1:	mov  al,ah
		inc  al
                cbw
                add  word ptr _regD1,ax
                jc   _inc_D1x
                clear_carry
                NEXTI
_inc_D1x:       adc  _regD1+2,0
		update_halfcarry
		NEXTI

_dec_D0:	mov  al,ah
		inc  al
                cbw
                sub  word ptr _regD0,ax
                jc   _dec_D0x
                clear_carry
                NEXTI
_dec_D0x:       sbb  _regD0+2,0
		update_halfcarry
		NEXTI
_dec_D1:	mov  al,ah
		inc  al
                cbw
                sub  word ptr _regD1,ax
                jc   _dec_D1x
                clear_carry
                NEXTI
_dec_D1x:       sbb  _regD1+2,0
		update_halfcarry
		NEXTI


mov_Dx_as       macro POINTER, REGISTER
                align 2
_mov_&POINTER&_&REGISTER&:
                mov   al,_reg&REGISTER&-1
                and   al,0fh
		mov   _reg&POINTER&+2,al
_mov_&POINTER&_&REGISTER&_s:
                mov   ax,word ptr _reg&REGISTER&
		mov   word ptr _reg&POINTER&,ax
		NEXTI
                endm

                mov_Dx_as D0 A
                mov_Dx_as D1 A
                mov_Dx_as D0 C
                mov_Dx_as D1 C





xch_Dx_as       macro POINTER, REGISTER
                align 2
_xch_&REGISTER&_&POINTER&:
                mov   al,_reg&REGISTER&-1
                and   al,0fh
		xchg  al,_reg&POINTER&+2
                mov   _reg&REGISTER-1,al
_xch_&REGISTER&_&POINTER&_s:
                mov   ax,word ptr _reg&REGISTER&
		xchg  ax,word ptr _reg&POINTER&
                mov   word ptr _reg&REGISTER&,ax
		NEXTI
                endm

                xch_Dx_as D0 A
                xch_Dx_as D1 A
                xch_Dx_as D0 C
                xch_Dx_as D1 C



_con_Reg_n:
                ; al[3-0]=field, al[5-4]=reg, al[7-6]=operation, ah[3-0]=n
                mov  dl,al
                call _con0
                ; di=destination, bh=length, bl=start, ah=n
                or   bx,bx
                je   _con16
                mov  al,dl
                shr  al,6    ; rol al,2 ??
                and  al,3
                je   _add_Reg_n
_con15:         sub  al,2
                je   _sub_Reg_n
_con16:         jmp  invalid

                ; di=destination, bh=length, bl=start, ah=n
_add_Reg_n:     mov  dl,ah
                call maj_w
                push di
                xor  ax,ax
                mov  al,bl
                shr  al,1
                add  di,ax
                dec  bh
                shr  bl,1
                jc   _add1
                or   bh,bh
                stc
                jmp  short _add4
                ;
; add to high nibble
_add1:          shl  dl,4
                add  dl,00fh
                stc
                adc  [di],dl
                mov  dl,0
                inc  di
                dec  bh
                jmp  short _add4
; add to byte(s)
_add2:          adc  [di],dl
                mov  dl,0
                inc  di
                dec  bh
                dec  bh
_add4:          js   _add5
                jne  _add2
; add to low nibble
                mov  al,[di]
                mov  bh,al
                adc  al,dl
_add4a:         update_halfcarry
                mov  ah,bh
                and  ax,0f00fh
                or   al,ah
                mov  [di],al
                jmp  short _add6
_add5:          update_carry
_add6:          pop  di
                maj_a
                NEXT

                ; di=destination, bh=length, bl=start, ah=n
_sub_Reg_n:     mov  dl,ah
                call maj_w
                push di
                xor  ax,ax
                mov  al,bl
                shr  al,1
                add  di,ax
                dec  bh
                shr  bl,1
                jc   _sub1
                or   bh,bh
                stc
                jmp  short _sub4
                ;
; sub from high nibble
_sub1:          shl  dl,4
                add  dl,00fh
                stc
                sbb  [di],dl
                mov  dl,0
                inc  di
                dec  bh
                jmp  short _sub4
; sub from byte(s)
_sub2:          sbb  [di],dl
                mov  dl,0
                inc  di
                dec  bh
                dec  bh
_sub4:          js   _add5      ; _sub5
                jne  _sub2
; sub from low nibble
                mov  al,[di]
                mov  bh,al
                sbb  al,dl
                jmp  short _add4a

comment !
_sub4a:         update_halfcarry
                mov  ah,bh
                and  ax,0f00fh
                or   al,ah
                mov  [di],al
                jmp  short _sub6
_sub5:          update_carry
_sub6:          pop  di
                maj_a
                NEXT
 !


_srb_Reg_n:
                ; al[3-0]=field, al[5-4]=reg, al[7-6]=operation
                mov  dl,al
                call _con0
                ; di=destination, bh=length, bl=start
                or   bx,bx
                je   _srb16
                mov  al,dl
                shr  al,6      ; rol al,2 ??
                and  al,3
                je   _srb_Reg
_srb16:         jmp  invalid


                ; di=destination, bh=length, bl=start
_srb_Reg:
                call maj_w
                push di
                xor  ax,ax
                mov  al,bl
                add  al,bh
                dec  al
                mov  bl,al
                shr  al,1
                add  di,ax
                dec  bh
                shr  bl,1
                jnc  _srb1
                or   bh,bh
                jmp  short _srb4

; srb low nibble
_srb1:          mov  al,[di]
                mov  ah,al
                and  ax,0f00fh
                mov  dl,ah
                shr  al,1
                lahf
                or   al,dl
                mov  [di],al
                sahf
                dec  di
                dec  bh
                jmp  short _srb4
; srb byte(s)
_srb2:          rcr  byte ptr [di],1
                dec  di
                dec  bh
                dec  bh
_srb4:          js   _srb5
                jne  _srb2
; srb high nibble
                mov  al,[di]
                mov  dl,al
                rcr  al,1
                ; update SB
                mov  ah,al
                and  ah,8
                je   _srb4a
		or   _hwstatus,2       ; SB
_srb4a:         mov  ah,dl
                and  ax,00ff0h
                or   al,ah
                mov  [di],al
                jmp  short _srb6
_srb5:          ; update SB
                jnc  _srb6
		or   _hwstatus,2       ; SB
_srb6:          pop  di
                maj_a
                NEXT






_con0:
                ; inputs:
                ; al[3-0]=field, al[5-4]=reg, al[7-6]=operation, ah[3-0]=n
                ; output:
                ; di: point to destination reg
                ; bh: field length, bl: start of field
                shr  al,4
                and  al,3
                jne  _con1
                mov  di,offset _regA
                jmp  short _con4
_con1:          dec  al
                jne  _con2
                mov  di,offset _regB
                jmp  short _con4
_con2:          dec  al
                jne  _con3
                mov  di,offset _regC
                jmp  short _con4
_con3:          mov  di,offset _regD
_con4:          mov  al,dl
                and  al,0fh
                cmp  al,0fh
                je   _con13
                or   al,al
                jne  _con5
                ; P field
                mov  bl,_Pointer
                mov  bh,1
                jmp  short _con14
_con5:          dec  al
                jne  _con6
                ; WP
                mov  bx,0100h
                add  bh,_Pointer
                jmp  short _con14
_con6:          dec  al
                jne  _con7
                ; XS
                mov  bx,0102h
                jmp  short _con14
_con7:          dec  al
                jne  _con8
                ; X
                mov  bx,0300h
                jmp  short _con14
_con8:          dec  al
                jne  _con9
                ; S
                mov  bx,010fh
                jmp  short _con14
_con9:          dec  al
                jne  _con10
                ; M
                mov  bx,0c03h
                jmp  short _con14
_con10:         dec  al
                jne  _con11
                ; B
                mov  bx,0200h
                jmp  short _con14
_con11:         dec  al
                jne  _con12
                ; W
                mov  bx,1000h
                jmp  short _con14
_con12:         sub  al,8
                je   _con13
                xor  bx,bx
                jmp  short _con14
_con13:         ; A
                mov  bx,0500h
_con14:         ret



