; ********************************************************************
;               mulation du processeur Saturn par le 8086
;                       J-F Garnier 1993, 2002
; --------------------------------------------------------------------
; Module sat_dec.asm : dcodage des instructions, table tab_opcode
; --------------------------------------------------------------------
; Version 1   16/03/93
;             04/09/93 :
;            commentaires,
;            corrig decode9x, decodeAx,  decodeBx,
;            complt tab_opcode1x
; Version 2   28/12/94
; version 2.1 09/09/01 HP42S support
; Version 3.0 03/10/02 12 bits jump table
; ********************************************************************




; macros de dfinitions des tables d'opcode arithmtiques

TAB_ARITH1 	macro ADR
		dw  _add_A_B&ADR&, _add_B_C&ADR&, _add_C_A&ADR&, _add_D_C&ADR&
		dw  _add_A_A&ADR&, _add_B_B&ADR&, _add_C_C&ADR&, _add_D_D&ADR&
		dw  _add_B_A&ADR&, _add_C_B&ADR&, _add_A_C&ADR&, _add_C_D&ADR&
		dw  _dec_A&ADR&,   _dec_B&ADR&,   _dec_C&ADR&,   _dec_D&ADR&
		endm

TAB_ARITH2 	macro ADR
		dw  _clr_A&ADR&,   _clr_B&ADR&,   _clr_C&ADR&,   _clr_D&ADR&
		dw  _mov_A_B&ADR&, _mov_B_C&ADR&, _mov_C_A&ADR&, _mov_D_C&ADR&
		dw  _mov_B_A&ADR&, _mov_C_B&ADR&, _mov_A_C&ADR&, _mov_C_D&ADR&
		dw  _xch_A_B&ADR&, _xch_B_C&ADR&, _xch_A_C&ADR&, _xch_C_D&ADR&
		endm

TAB_ARITH3 	macro ADR
		dw  _sub_A_B&ADR&, _sub_B_C&ADR&, _sub_C_A&ADR&, _sub_D_C&ADR&
		dw  _inc_A&ADR&,   _inc_B&ADR&,   _inc_C&ADR&,   _inc_D&ADR&
		dw  _sub_B_A&ADR&, _sub_C_B&ADR&, _sub_A_C&ADR&, _sub_C_D&ADR&
		dw  _subr_A_B&ADR&,_subr_B_C&ADR&,_subr_C_A&ADR&,_subr_D_C&ADR&
		endm

TAB_ARITH4 	macro ADR
		dw  _sl_A&ADR&,  _sl_B&ADR&,  _sl_C&ADR&,  _sl_D&ADR&
		dw  _sr_A&ADR&,  _sr_B&ADR&,  _sr_C&ADR&,  _sr_D&ADR&
		dw  _neg_A&ADR&, _neg_B&ADR&, _neg_C&ADR&, _neg_D&ADR&
		dw  _not_A&ADR&, _not_B&ADR&, _not_C&ADR&, _not_D&ADR&
		endm

TAB_CMP1 	macro ADR
		dw  _eq_A_B&ADR&, _eq_B_C&ADR&, _eq_C_A&ADR&, _eq_D_C&ADR&
		dw  _ne_A_B&ADR&, _ne_B_C&ADR&, _ne_C_A&ADR&, _ne_D_C&ADR&
		dw  _eq_A&ADR&,   _eq_B&ADR&,   _eq_C&ADR&,   _eq_D&ADR&
		dw  _ne_A&ADR&,   _ne_B&ADR&,   _ne_C&ADR&,   _ne_D&ADR&
		endm

TAB_CMP2 	macro ADR
		dw  _gt_A_B&ADR&, _gt_B_C&ADR&, _gt_C_A&ADR&, _gt_D_C&ADR&
		dw  _gt_B_A&ADR&, _gt_C_B&ADR&, _gt_A_C&ADR&, _gt_C_D&ADR&
		dw  _ge_A_B&ADR&, _ge_B_C&ADR&, _ge_C_A&ADR&, _ge_D_C&ADR&
		dw  _ge_B_A&ADR&, _ge_C_B&ADR&, _ge_A_C&ADR&, _ge_C_D&ADR&
		endm


; ------------------------------------------------------
; table principale des opcodes du Saturn
; ------------------------------------------------------

		align 2





comment !
tabopcode       dw  _rtnsxm, _rtn,    _rtnsc,   _rtncc
		dw  _sethex, _setdec, _rstk_c,  _c_rstk
		dw  _clrst,  _c_st,   _st_c,    _cstex
		dw  _incr_p, _decr_p,  decode0E, _rti

		dw  4 dup (decode1x)
		dw  decode1x, decode15, _inc_D0,  _inc_D1
		dw  _dec_D0,  _ld_D0_2, _ld_D0_4, _ld_D0_5
		dw  _dec_D1,  _ld_D1_2, _ld_D1_4, _ld_D1_5

		dw  16 dup (_p_x)

                dw  16 dup (_lchex)

		dw  16 dup (_goc)

		dw  16 dup (_gonc)

		dw  16 dup (_goto)

		dw  16 dup (_gosub)

		dw  decode80,decode81,_clrhst,  _tsthst
		dw  _clr_st, _set_st, _tst_st0, _tst_st1
		dw  _tst_p0, _tst_p1, decode8A, decode8B
		dw  _golong, _govlng, _gosubl,  _gosbvl

		dw  16 dup (decode9x)

		dw  16 dup (decodeAx)

		dw  16 dup (decodeBx)

		TAB_ARITH1 _a

		TAB_ARITH2 _a

		TAB_ARITH3 _a

		TAB_ARITH4 _a

!

_init_tab:
                push si
                push di
                mov si, offset tabcode
                xor ax,ax
                mov bx,ax
                mov di,ax
init_tab1:
                mov cx,cs:[si]
                inc si
                inc si
                or  cx,cx
                je  init_tab9
                mov dx,cx
                ; cl = nb of entries, ch= nb of repeats
init_tab2:
                mov ch,dh
                mov ax,cs:[si]
                inc si
                inc si
init_tab3:
                add bx,bx
                mov [bx+tabopcode],ax
                inc di
                shr bx,1
                inc bh
                and bh,0fh
                jne init_tab4
                add bl,10h
                jnc init_tab4
                inc bl
init_tab4:      dec ch
                jne init_tab3
                dec cl
                jne init_tab2
                jmp short init_tab1
init_tab9:      mov ax,di
                pop di
                pop si
                ret
;_init_tab       endp



                align 2

                ;  #entries, #repeat
                ; **  means return in _nexti (3 nibs opcodes)
tabcode         db  16, 16    ; 0x
                dw  _rtnsxm, _rtn,    _rtnsc,   _rtncc
		dw  _sethex, _setdec, _rstk_c,  _c_rstk
		dw  _clrst,  _c_st,   _st_c,    _cstex
		dw  _incr_p, _decr_p,  decode0E, _rti

                db  80 , 1   ; 10x- 14x **
        	dw  _mov_R0_A, _mov_R1_A, _mov_R2_A, _mov_R3_A
		dw  _mov_R4_A, _mov_R5_A, _mov_R6_A, _mov_R7_A
		dw  _mov_R0_C, _mov_R1_C, _mov_R2_C, _mov_R3_C
		dw  _mov_R4_C, _mov_R5_C, _mov_R6_C, _mov_R7_C
                dw  _mov_A_R0, _mov_A_R1, _mov_A_R2, _mov_A_R3
		dw  _mov_A_R4, _mov_A_R5, _mov_A_R6, _mov_A_R7
		dw  _mov_C_R0, _mov_C_R1, _mov_C_R2, _mov_C_R3
		dw  _mov_C_R4, _mov_C_R5, _mov_C_R6, _mov_C_R7
		dw  _xch_A_R0, _xch_A_R1, _xch_A_R2, _xch_A_R3
		dw  _xch_A_R4, _xch_A_R5, _xch_A_R6, _xch_A_R7
		dw  _xch_C_R0, _xch_C_R1, _xch_C_R2, _xch_C_R3
		dw  _xch_C_R4, _xch_C_R5, _xch_C_R6, _xch_C_R7
		dw  _mov_D0_A, _mov_D1_A, _xch_A_D0, _xch_A_D1
		dw  _mov_D0_C, _mov_D1_C, _xch_C_D0, _xch_C_D1
		dw  _mov_D0_A_s, _mov_D1_A_s, _xch_A_D0_s, _xch_A_D1_s
		dw  _mov_D0_C_s, _mov_D1_C_s, _xch_C_D0_s, _xch_C_D1_s
               	dw  _sto_A_D0_a, _sto_A_D1_a, _lod_A_D0_a, _lod_A_D1_a
		dw  _sto_C_D0_a, _sto_C_D1_a, _lod_C_D0_a, _lod_C_D1_a
		dw  _sto_A_D0_b, _sto_A_D1_b, _lod_A_D0_b, _lod_A_D1_b
		dw  _sto_C_D0_b, _sto_C_D1_b, _lod_C_D0_b, _lod_C_D1_b
                db  1, 8    ; 150-157
                dw  decode15
                db  8, 1    ; 158-15F
		dw  _sto_A_D0_n, _sto_A_D1_n, _lod_A_D0_n, _lod_A_D1_n
		dw  _sto_C_D0_n, _sto_C_D1_n, _lod_C_D0_n, _lod_C_D1_n
                db  10, 16  ; 16x - 1Fx
		dw  _inc_D0,  _inc_D1
		dw  _dec_D0,  _ld_D0_2, _ld_D0_4, _ld_D0_5
		dw  _dec_D1,  _ld_D1_2, _ld_D1_4, _ld_D1_5

                db  1, 16       ; 2x
		dw  _p_0
                db  1, 240
                dw  _p_x
                db  6, 16      ; 30x to 35x
                dw  _lchex1, _lchex2, _lchex3, _lchex4, _lchex5, _lchex6
                db  1, 160     ; 3Xx
                dw  _lchex
                db  1, 1       ; 4xx
                dw  _rtnc
                db  1, 255
                dw  _goc
                db  1, 1       ; 5xx
                dw  _rtnnc
                db  1, 255
                dw  _gonc
                db  1, 0       ; 6xxx
                dw  _goto
                db  1, 0       ; 7xxx
                dw  _gosub

                db  32, 1      ; 80x - 81x **
        	dw  _mov_OUT_CS, _mov_OUT_C, _mov_A_IN, _mov_C_IN
		dw  _uncnfg, _config, _mov_C_ID, _shutdn
		dw  decode808, _add_C_P_1, _reset, _buscc
		dw  _mov_C_P_n, _mov_P_C_n, _sreq, _xch_C_P_n
                dw  _slc_A, _slc_B, _slc_C, _slc_D
		dw  _src_A, _src_B, _src_C, _src_D
		dw  decode818, decode819, decode81a, decode81b
		dw  _srb_A, _srb_B, _srb_C, _srb_D
                db  8, 16    ; 82x - 89x **
		dw  _clrhst,  _tsthst
		dw  _clr_st, _set_st, _tst_st0, _tst_st1
		dw  _tst_p0, _tst_p1
                db  32, 1    ;   8Ax - 8Bx **
		TAB_CMP1 _a
		TAB_CMP2 _a
                db  4, 16    ; 8Cx - 8Fx
		dw  _golong, _govlng, _gosubl,  _gosbvl

                db  0, 1       ; 9xx **
		TAB_CMP1 _p
		TAB_CMP1 _wp
		TAB_CMP1 _xs
		TAB_CMP1 _x
		TAB_CMP1 _s
		TAB_CMP1 _m
		TAB_CMP1 _b
		TAB_CMP1 _w
		TAB_CMP2 _p
		TAB_CMP2 _wp
		TAB_CMP2 _xs
		TAB_CMP2 _x
		TAB_CMP2 _s
		TAB_CMP2 _m
		TAB_CMP2 _b
		TAB_CMP2 _w

                db  0, 1      ; Axx  **
		TAB_ARITH1 _p
		TAB_ARITH1 _wp
		TAB_ARITH1 _xs
		TAB_ARITH1 _x
		TAB_ARITH1 _s
		TAB_ARITH1 _m
		TAB_ARITH1 _b
		TAB_ARITH1 _w
		TAB_ARITH2 _p
		TAB_ARITH2 _wp
		TAB_ARITH2 _xs
		TAB_ARITH2 _x
		TAB_ARITH2 _s
		TAB_ARITH2 _m
		TAB_ARITH2 _b
		TAB_ARITH2 _w

                db  0, 1     ; Bxx  **
		TAB_ARITH3 _p
		TAB_ARITH3 _wp
		TAB_ARITH3 _xs
		TAB_ARITH3 _x
		TAB_ARITH3 _s
		TAB_ARITH3 _m
		TAB_ARITH3 _b
		TAB_ARITH3 _w
		TAB_ARITH4 _p
		TAB_ARITH4 _wp
		TAB_ARITH4 _xs
		TAB_ARITH4 _x
		TAB_ARITH4 _s
		TAB_ARITH4 _m
		TAB_ARITH4 _b
		TAB_ARITH4 _w

                db  64, 16   ; Cx - Fx
		TAB_ARITH1 _a
                TAB_ARITH2 _a
                TAB_ARITH3 _a
                TAB_ARITH4 _a

                db  0, 0     ; end of table


; ---------------------------------------------------------------------


; dcodage des opcodes 0Exy



decode0E:	fetch_byte
		ror  al,4       ; pour faciliter dcodage
		xor  bx,bx
		mov  bl,al
		add  bx,bx
		jmp  cs:[tab_opcode0E+bx]



; macros de dfinitions d'entres de la table des opcodes 0Exy

TAB_0E 		macro ADR
		dw  _and_A_B&ADR&, _and_B_C&ADR&, _and_C_A&ADR&, _and_D_C&ADR&
		dw  _and_B_A&ADR&, _and_C_B&ADR&, _and_A_C&ADR&, _and_C_D&ADR&
		dw  _or_A_B&ADR&,  _or_B_C&ADR&,  _or_C_A&ADR&,  _or_D_C&ADR&
		dw  _or_B_A&ADR&,  _or_C_B&ADR&,  _or_A_C&ADR&,  _or_C_D&ADR&
		endm

TAB_INV8	macro
		rept 8
		dw  invalid
		endm
		endm


; table des opcodes 0Exy
		align 2
tab_opcode0E    label word
		TAB_0E _p
		TAB_0E _wp
		TAB_0E _xs
		TAB_0E _x
		TAB_0E _s
		TAB_0E _m
		TAB_0E _b
		TAB_0E _w
		rept 7
		TAB_INV8
		TAB_INV8
		endm
		TAB_0E _a



; ---------------------------------------------------------------------

; dcodage des opcodes 150y-157y

decode15:
		fetch_byte
		ror  al,4       ; pour faciliter dcodage
	        xor  bx,bx
		mov  bl,al      ; here, 0<bl<127
		add  bl,bl
		jmp  cs:[tab_opcode15+bx]

; macro de dfinitions d'entres de la table des opcodes 15xy

TAB_CHAMP 	macro INSTRUCT
		dw  &INSTRUCT&_p, &INSTRUCT&_wp, &INSTRUCT&_xs, &INSTRUCT&_x
		dw  &INSTRUCT&_s, &INSTRUCT&_m,  &INSTRUCT&_b,  &INSTRUCT&_w
		endm

; table des opcodes 15xy
		align 2
tab_opcode15    label word
		TAB_CHAMP _sto_A_D0
		TAB_INV8
		TAB_CHAMP _sto_A_D1
		TAB_INV8
		TAB_CHAMP _lod_A_D0
		TAB_INV8
		TAB_CHAMP _lod_A_D1
		TAB_INV8
		TAB_CHAMP _sto_C_D0

;		TAB_INV8
                rept 7
                dw  invalid
                endm
                dw  _stoil_C_D0_8  ; 154f write il for ilmailbox emulation

		TAB_CHAMP _sto_C_D1
		TAB_INV8
		TAB_CHAMP _lod_C_D0

;		TAB_INV8
                rept 6
                dw  invalid
                endm
                dw  _lodil_C_D0_7  ; 156e read il for ilmailbox emulation
                dw  invalid

		TAB_CHAMP _lod_C_D1
		TAB_INV8




; ---------------------------------------------------------------------


; dcodage des opcodes 808x :
decode808:
                fetch_byte
                shr  al,4
		xor  bx,bx
		mov  bl,al
		add  bx,bx
		jmp  cs:[tab_opcode808+bx]

                align 2
tab_opcode808   dw  _inton, _rsi, _lahex, _buscb
                dw  _clrb_A_n, _setb_A_n, _isclr_A_n, _isset_A_n
                dw  _clrb_C_n, _setb_C_n, _isclr_C_n, _isset_C_n
                dw  _movi_PC_A, _buscd, _movi_PC_C, _intoff


; ---------------------------------------------------------------------

; dcodage des opcodes 818-81b


decode818:
                incr_pc
;                test _flagbrk,0ffh
;                jne  inv81x
                fetch_3nib
                ; al[3-0]=field, al[5-4]={A,B,C,D} reg, al[7-6]=operation, ah[3-0]=n
                ; operation: 0: +CON(1-16), 2: -CON(1-16)
                ; (extension: 1: +CON(17-32), 3: -CON(17-32))
                jmp  _con_Reg_n
inv81x:         jmp  invalid

decode819:      ; srb reg fs
                incr_pc
;                test _flagbrk,0ffh
;                jne  inv81x
                fetch_byte
                ; al[3-0]=field, al[5-4]={A,B,C,D} reg, al[7-6]=operation
                ; operation: 0=SRB
                ; (extension: 1-3: ??)
                jmp _srb_Reg_n

decode81a:      ; mov or xchg [A,C] <-> [R0,R1,R2,R3,R4] fs
                jmp  invalid    ; TBD
                incr_pc
                fetch_3nib
                ; al[3-0]=field, al[7-4]=operation, ah[3]={A,C} reg, ah[2-0]=Rx reg
                ; operation: 0=mov Rx,{A,C} ; 1=mov {A,C},Rx ; 2=xchg {A,C},Rx
                ; (extension  4=ST+, 5=ST-, 6=RC+, 7=RC- )
                NEXT

decode81b:      ; 81bx new instructions on PC
;                test _flagbrk,0ffh
;                jne  inv81x
                fetch_byte
                shr  al,4
		xor  bx,bx
		mov  bl,al
		add  bx,bx
		jmp  cs:[tab_opcode81b+bx]

tab_opcode81b   dw  invalid, invalid, _mov_PC_A, _mov_PC_C
                dw  _mov_A_PC, _mov_C_PC, _xch_A_PC, _xch_C_PC
                dw  4 dup(invalid)
                dw  4 dup(invalid)



; fpu interface xtensions:
; FMULT    in: 0.1 <= C, A < 1 ;  out: 0.01 <= C < 1
; FDIV     in: 0.1 <= C, A < 1 ;  out: 0.01 <= C < 1
; FSQRT    in: 0.01 <= C < 1   ;  out: 0.1  <= C < 1
; FINV
; FPTAN    in: 0 < C < PI/4    ;  out:
; FPATAN
; FLOG10   in: 0.1 <= C < 1     ; out: 0 <= C < 1
; FPOW10   in: 0 <= C < 1      ; out: 1 <= C < 10

