; ********************************************************************
;               mulation du processeur Saturn par le 8086
;                       J-F Garnier 1993, 95
; --------------------------------------------------------------------
; Module sat_mem.asm : mulation des instructions d'accs mmoire
; --------------------------------------------------------------------
; Version 1.0 06/09/93
;   prototype
; Version 1.1 04/11/95
; ********************************************************************



; routines accs mmoire :
; A=DAT0 fs
; C=DAT0 fs
; A=DAT1 fs
; C=DAT1 fs
; DAT0=A fs
; DAT0=C fs
; DAT1=A fs
; DAT1=C fs



exec_mem        macro INSTRUCT, REGIS, POINTER, CHAMP
		mov   bx, offset _reg&POINTER&
		mov   di, offset _reg&REGIS&
		jmp   exec_&INSTRUCT&_&CHAMP&
		endm

exec_mems       macro INSTRUCT, REGIS, POINTER, CHAMP
		mov   bx, offset _reg&POINTER&
		mov   di, offset _reg&REGIS&
		jmp   short exec_&INSTRUCT&_&CHAMP&
		endm







build_load      macro INSTRUCT
		local mem_p_i, mem_p_x, tab_mem_wp

&INSTRUCT&_p:   push  di
		call  maj_w
		xor   ah,ah
		mov   al,_Pointer
		shr   al,1
		jc    mem_p_i
		; paire, quartet infrieur
		add   di,ax
		call  &INSTRUCT&_lonib
		jmp   short mem_p_x
mem_p_i:        ; impaire, quartet suprieur
		add   di,ax
		call  &INSTRUCT&_hinib
mem_p_x:        pop   di
		maj_a
		pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_wp:  push  di
		call  maj_w
		xor   bx,bx
		mov   bl,_Pointer
		add   bx,bx
		call  cs:[bx+tab_mem_wp]
                pop   di
		maj_a
                pop   cx
		pop   si
		pop   es
		NEXT
tab_mem_wp      dw    &INSTRUCT&_1,  &INSTRUCT&_2,  &INSTRUCT&_3,  &INSTRUCT&_4
		dw    &INSTRUCT&_5,  &INSTRUCT&_6,  &INSTRUCT&_7,  &INSTRUCT&_8
		dw    &INSTRUCT&_9,  &INSTRUCT&_10, &INSTRUCT&_11, &INSTRUCT&_12
		dw    &INSTRUCT&_13, &INSTRUCT&_14, &INSTRUCT&_15, &INSTRUCT&_16



&INSTRUCT&_n:   push  di
		call  maj_w
		add   bx,bx
		call  cs:[bx+tab_mem_wp]
		pop   di
		maj_a
		pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_xs:
		inc   di
		call  &INSTRUCT&_lonib
		pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_x:
		call  &INSTRUCT&_3
		pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_s:
		add   di,7
		call  &INSTRUCT&_hinib
                pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_m:   push  di
		call  maj_w
		inc   di
		call  &INSTRUCT&_hinib
		inc   di
		call  &INSTRUCT&_11
		pop   di
		maj_a
		pop   cx
		pop   si
		pop   es
		NEXT

		endm







; code d'excution d'instructions accs mmoire

; cr un pointeur mmoire  partir du registre D0 ou D1 point par bx
get_pointer:
		mov   si,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bx-si
bld_pointer:
		xor   cl,cl
		shr   si,1
		rcl   cl,3
		add   bx,bx
comment !
                cmp   bx,10
                jne   bp1
                cmp   si,02000h
                jc    bp1
    		mov   bx,[_tab_seg+bx]
		mov   es,bx
                stc
                ret
bp1:
!
		cmp   bx,4      ; pour test criture ROMs internes !!!
    		mov   bx,[_tab_seg+bx]
		mov   es,bx
		ret





		irp   CHAMP,<p, wp, xs, x, m, w>
		local load00
exec_load_&CHAMP&:
		push  es
		push  si
		push  cx
		call  get_pointer
		; es:si, cl : pointeur mmoire source
		; ds:di : pointeur sur registre destination
		or    bx,bx
		je    load00
		jmp   load_&CHAMP&
load00:         jmp   load00_&CHAMP&
		endm


                align 2
_lod_A_D0_a:    exec_mems load A D0 a
_lod_C_D0_a:    exec_mems load C D0 a
_lod_A_D1_a:    exec_mems load A D1 a
_lod_C_D1_a:    exec_mems load C D1 a

exec_load_a:
		mov   ax,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bl-ax
		add   bx,bx
		mov   bx,[_tab_seg+bx]
                xchg  ax,bx
                or    ax,ax
                je    exec_load_a0
                mov   dx,es
                mov   es,ax
		shr   bx,1
                mov   ax,es:[bx]
                mov   bx,es:[bx+1]
                jnc   exec_load_a1
                shr   ax,4
                shr   bx,4
                mov   ah,bl
exec_load_a1:   mov   [di],ax
                mov   [di-1],bh
                mov   es,dx
                NEXTI
exec_load_a0:   xor   ax,ax
                mov   [di],ax
                mov   [di-1],al
                NEXTI



                align 2
_lod_A_D0_b:    exec_mems load A D0 b
_lod_C_D0_b:    exec_mems load C D0 b
_lod_A_D1_b:    exec_mems load A D1 b
_lod_C_D1_b:    exec_mems load C D1 b

exec_load_b:
		mov   ax,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bl-ax
		add   bx,bx
		mov   bx,[_tab_seg+bx]
                xchg  ax,bx
                or    ax,ax
                je    exec_load_b0
                mov   dx,es
                mov   es,ax
		shr   bx,1
                mov   ax,es:[bx]
                jnc   exec_load_b1
                shr   ax,4
exec_load_b1:   mov   [di],al
                mov   es,dx
                NEXTI
exec_load_b0:   xor   ax,ax
                mov   [di],al
                NEXTI


                align 2
_lod_A_D0_s:    exec_mems load A D0 s
_lod_C_D0_s:    exec_mems load C D0 s
_lod_A_D1_s:    exec_mems load A D1 s
_lod_C_D1_s:    exec_mems load C D1 s

exec_load_s:
		mov   ax,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bl-ax
		add   bx,bx
		mov   bx,[_tab_seg+bx]
                xchg  ax,bx
                or    ax,ax
                je    exec_load_s0
                mov   dx,es
                mov   es,ax
		shr   bx,1
                mov   al,es:[bx]
                jc    exec_load_s1
            	shl   al,4
exec_load_s1:   mov   ah,[di+7]
		and   ax,0ff0h
		or    al,ah
                mov   [di+7],al
                mov   es,dx
                NEXT
exec_load_s0:   and   byte ptr [di+7],0fh
                NEXT





; load_n et store_n :
exec_load_n:
                fetch_byte
                shr   al,4
                and   ax,15
; al contient d-1, d tant le nombre d'octets  transfrer
                push  es
		push  si
		push  cx
		push  ax
		call  get_pointer
		or    bx,bx
		je    exec_load0
		pop   bx
		; es:si, cl : pointeur mmoire,
		; ds:di : pointeur sur registre (source ou destination)
		; bx: nbre d'octets-1
		jmp   load_n
exec_load0:     pop   bx
		jmp   load00_n




; support for HPIL mailbox

; DAT0=C 8 in HPIL mailbox
_stoil_C_D0_8:
		mov   bx, offset _regD0
		mov   di, offset _regC
                push  es
		push  si
		push  cx
		call  get_pointer
		jc    _stoil0     ; pour test criture ROMs !!!
		or    bx,bx
		je    _stoil0
		; es:si, cl : pointeur mmoire,
		; ds:di : pointeur sur registre (source ou destination)
                call  maj_w
                or    cl,cl
		je    _stoil1
		; cl#0, il faut ecrire @di[3-0] dans hinib
		call  store_hinib
                call  store_7
                jmp   short _stoil2
_stoil1:        call  store_8
_stoil2:        pop   cx
		pop   si
		pop   es
		mov   ax,10       ; WRIL
                jmp   retour
_stoil0:        pop   cx
		pop   si
		pop   es
		NEXT



; C=DAT0 7 from HPIL mailbox
_lodil_C_D0_7:
		mov   bx, offset _regD0
		mov   di, offset _regC
                push  es
		push  si
		push  cx
		call  get_pointer
		or    bx,bx
		je    _lodil0
		; es:si, cl : pointeur mmoire,
		; ds:di : pointeur sur registre (source ou destination)
                push  di
		call  maj_w
                call  load_7
		pop   di
		maj_a
		pop   cx
		pop   si
		pop   es
		mov   ax,11     ; RDIL
                jmp   retour
_lodil0:        pop   cx
		pop   si
		pop   es
                mov   bx,6
		jmp   load00_n   ; was _clr_n







; -------------------------------------------------------------------
; chargement d'un registre depuis la mmoire
; -------------------------------------------------------------------



load_byte       macro
		mov   ax,es:[si]
		shr   ax,cl
		mov   [di],al
		inc   si
		inc   di
		endm

; charge un quartet es:si, cl dans hinib di[7-4]
; si cl=0, es:si[3-0], sinon es:si[7-4]
; incremente es:si,cl
load_hinib:     mov   al,es:[si]
		xor   cl,4
		jne   load_hinib1
		inc   si
load_hinib1:	shl   al,cl
		mov   ah,[di]
		and   ax,0ff0h
		or    al,ah
		mov   [di],al
		ret



load_16:        load_byte
load_14:        load_byte
load_12:        load_byte
load_10:        load_byte
load_8:         load_byte
load_6:         load_byte
load_4:         load_byte
load_2:         load_byte
		ret

load_15:        load_byte
load_13:        load_byte
load_11:        load_byte
load_9:         load_byte
load_7:         load_byte
load_5:         load_byte
load_3:         load_byte
load_1:
; charge un quartet es:si, cl dans lonib di[3-0]
; si cl=0, es:si[3-0], sinon es:si[7-4]
load_lonib:	mov   al,es:[si]
		sar   al,cl
		mov   ah,[di]
		and   ax,0f00fh
		or    al,ah
		mov   [di],al
		ret

load_a:         mov   ax,es:[si]
		sar   ax,cl
		mov   bx,es:[si+1]
		sar   bx,cl
		mov   ah,bl
		mov   [di],ax
		mov   [di-1],bh
		pop   cx
		pop   si
		pop   es
		NEXTI

load_b:
		mov   ax,es:[si]
		sar   ax,cl
		mov   [di],al
                pop   cx
		pop   si
		pop   es
		NEXTI


load_w:         mov   ax,es:[si]
		sar   ax,cl
		mov   bx,es:[si+1]
		sar   bx,cl
		mov   ah,bl
		mov   [di],ax

		mov   ax,es:[si+2]
		sar   ax,cl
		mov   bx,es:[si+3]
		sar   bx,cl
		mov   ah,bl
		mov   [di+2],ax

		mov   ax,es:[si+4]
		sar   ax,cl
		mov   bx,es:[si+5]
		sar   bx,cl
		mov   ah,bl
		mov   [di+4],ax

		mov   ax,es:[si+6]
		sar   ax,cl
		mov   bx,es:[si+7]
		sar   bx,cl
		mov   ah,bl
		mov   [di+6],ax

		pop   cx
		pop   si
		pop   es
		maj_a
		NEXT

comment !
; version optimis de load_w,  mettre au point.
new_load_w:     or    cl,cl
		jne   load_w1
		mov   ax,es:[si]
		mov   [di],ax
		mov   ax,es:[si+2]
		mov   [di+2],ax
		mov   ax,es:[si+4]
		mov   [di+4],ax
		mov   ax,es:[si+6]
		mov   [di+6],ax
		pop   cx
		pop   si
		pop   es
		maj_a
		NEXT
load_w1:
		mov   al,es:[si]        [ x x 0 x ]

		mov   bx,es:[si+1]     [ 4 3 2 1 ]
		mov   dx,es:[si+3]     [ 8 7 6 5 ]



; j'ai droit  8 instructions:
sol1:		rol   bx,cl            [ 3 2 1 4 ]
		rol   dx,cl            [ 7 6 5 8 ]
		mov   ah,bl            [ 1 4 0 -]
		and   ax,0f00fh
		or    al,ah            [ x x  1 0 ]
		xchg  al,bl            [ x x 1 4 ]
		mov   ah,dl            [ 5 8 1 4 ]
		and   ax,0f00fh
		or    al,ah            [ x x 5 4 ]
		xchg  al,dl            [ x x 5 8 ]

sol2:		mov   ah,bl            [ 2 1 0 x ]
		shr   ax,cl            [ - 2 1 0 ]
		rol   bx,cl            [ 3 2 1 4 ]
		xchg  al,bl        ax: [ - 2 1 4 ]    bx : [ 3 2 1 0 ]
		rol   dx,cl            [ 7 6 5 8 ]

sol3:           mov   ah,bh        ax: [ 4 3 0 x ]
                and   ax,00ff0h        [ - 3 0 - ]
                or    al,ah            [ - 3 0 3 ]
                xchg  al,bh        bx: [ 0 3 2 1 ]   al [ 4 3 ]
                mov   ah,dh        ax: [ 8 7 4 3 ]
                and   ax,00ff0h        [ - 7 4 - ]
                or    al,ah            [ 4 7]
                mov  dh,al             [ 4 7 6 5 ]


		mov   ax,es:[si]       [ 2 1 0 x ]
		mov   bx,es:[si+2]     [ 6 5 4 3 ]



		mov   [di],bx
		mov   [di+2],dx


		pop   cx
		pop   si
		pop   es
		maj_a
		NEXT
!

; dfinitions du reste du code
		build_load load




load00_p:       mov  bl,_Pointer
                mov  bh,bl
                jmp  short load_n0
load00_wp:      mov  bh,_Pointer
                mov  bl,0
                jmp  short load_n0
load00_xs:      mov  bx,0202h
                jmp  short load_n0
load00_x:       mov  bx,0200h
                jmp  short load_n0
load00_s:       mov  bx,0f0fh
                jmp  short load_n0
load00_m:       mov  bx,0e03h
                jmp  short load_n0
load00_w:       mov  bx,0f00h
                jmp  short load_n0
load00_n:       xchg bl,bh
load_n0:        push di
                call maj_w
                mov  ax,bx
                shr  bl,1
                xor  bh,bh
                add  di,bx
                sub  ah,al
                shr  al,1
                jnc  load_n1
                and  byte ptr [di],0fh
                inc  di
                dec  ah
load_n1:        xor  al,al
                or   ah,ah
load_n2:        js   load_n4
                je   load_n3
                mov  [di],al
                inc  di
                sub  ah,2
                jmp  load_n2
load_n3:        and  byte ptr [di],0f0h
load_n4:        pop   di
                maj_a
                pop   cx
		pop   si
		pop   es
                NEXT


load00_b:       xor  al,al
                mov  [di],al
		jmp  short load00_ab
load00_a:       xor  ax,ax
                mov  [di],ax
                mov  [di-1],al
load00_ab:	pop   cx
		pop   si
		pop   es
                NEXTI


; ======================================================================


; il faut inverser la signification de cl:
; c'est maintenant le dcallage  faire subir  la source (registre)


build_store     macro INSTRUCT
		local mem_p_i, mem_p_x, mem_p_1, mem_p_2
		local tab_mem_wp, mem_wp_0
		local mem_xs_1, mem_xs_2
		local mem_x_1, mem_x_2
		local mem_s_1, mem_s_2
		local mem_m_1, mem_m_2

&INSTRUCT&_p:   call  maj_w
		xor   ah,ah
		mov   al,_Pointer
		shr   al,1
		jc    mem_p_i
		; paire, quartet infrieur
		add   di,ax
		or    cl,cl
		jne   mem_p_1
		; cl=0, il faut ecrire @di[3-0] dans lonib
		call  &INSTRUCT&_lonib
		jmp   short mem_p_x
mem_p_1:        ; cl#0, il faut ecrire @di[3-0] dans hinib
		call  &INSTRUCT&_hinib
		jmp   short mem_p_x
mem_p_i:        ; impaire, quartet suprieur
		add   di,ax
		or    cl,cl
		jne   mem_p_2
		; cl=0, il faut ecrire @di[7-4] dans lonib
		mov   cl,4
		call  &INSTRUCT&_lonib
		jmp   short mem_p_x
mem_p_2:	; cl#0, il faut ecrire @di[7-4] dans hinib
		mov   cl,0
		call  &INSTRUCT&_hinib
mem_p_x:        pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_n:   call  maj_w
		jmp   short mem_wp_0

&INSTRUCT&_wp:  call  maj_w
		xor   bx,bx
		mov   bl,_Pointer
mem_wp_0:       or    cl,cl
		je    mem_wp_1
		; cl#0, il faut ecrire @di[3-0] dans hinib
		call  &INSTRUCT&_hinib
		dec   bx
		js    mem_wp_2    ; il n'y avait qu'un quartet
		; pointe sur quartet destination suivant
		inc   si
		; cl reste #0 pour ecriture octet source [11-4]
mem_wp_1:       add   bx,bx
		call  cs:[bx+tab_mem_wp]
mem_wp_2:       pop   cx
		pop   si
		pop   es
		NEXT
tab_mem_wp      dw    &INSTRUCT&_1,  &INSTRUCT&_2,  &INSTRUCT&_3,  &INSTRUCT&_4
		dw    &INSTRUCT&_5,  &INSTRUCT&_6,  &INSTRUCT&_7,  &INSTRUCT&_8
		dw    &INSTRUCT&_9,  &INSTRUCT&_10, &INSTRUCT&_11, &INSTRUCT&_12
		dw    &INSTRUCT&_13, &INSTRUCT&_14, &INSTRUCT&_15, &INSTRUCT&_16

&INSTRUCT&_xs:  inc   di
		or    cl,cl
		jne   mem_xs_1
		; cl=0, il faut ecrire @di[3-0] dans lonib
		call  &INSTRUCT&_lonib
		jmp   short mem_xs_2
mem_xs_1:       ; cl#0, il faut ecrire @di[3-0] dans hinib
		call  &INSTRUCT&_hinib
mem_xs_2:       pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_x:   or    cl,cl
		jne   mem_x_1
		call  &INSTRUCT&_3
		jmp   short mem_x_2
mem_x_1:        ; cl#0, il faut ecrire @di[3-0] dans hinib
		call  &INSTRUCT&_hinib
		; pointe sur quartet destination suivant
		inc   si
		; cl reste #0 pour ecriture octet source [11-4]
		call  &INSTRUCT&_2
mem_x_2:        pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_s:   add   di,7
		or    cl,cl
		jne   mem_s_1
		; cl=0, il faut ecrire @di[7-4] dans lonib
		mov   cl,4
		call  &INSTRUCT&_lonib
		jmp   short mem_s_2
mem_s_1:	; cl#0, il faut ecrire @di[7-4] dans hinib
		mov   cl,0
		call  &INSTRUCT&_hinib
mem_s_2:        pop   cx
		pop   si
		pop   es
		NEXT

&INSTRUCT&_m:   call  maj_w
		inc   di
		or    cl,cl
		jne   mem_m_1
		; cl=0, il faut ecrire @di[11-4] dans octets destination
		mov   cl,4
		call  &INSTRUCT&_12
		jmp   short mem_m_2
mem_m_1:        ; cl#0, il faut ecrire @di[7-4] dans hinib
		mov   cl,0
		call  &INSTRUCT&_hinib
		inc   si
		inc   di
		; puis ecrire 5 octets @di[7-0] dans octets destination
		; puis ecrire @di[3-0] dans lonib
		call  &INSTRUCT&_11
mem_m_2:        pop   cx
		pop   si
		pop   es
		NEXT


		endm





; -------------------------------------------------------------------
; criture d'un registre dans la mmoire
; -------------------------------------------------------------------



; ecrit un octet dans l'octet de la RAM pointee par es:si
; si cl=0, ecrit @di[7-0], sinon ecrit @di[11-4]
store_byte      macro
		mov   ax,[di]
		shr   ax,cl
		mov   es:[si],al
		inc   si
		inc   di
		endm

; ecrit un quartet dans le hinib de la RAM pointee par es:si
; si cl=0, ecrit @di[7-4], sinon ecrit @di[3-0]
store_hinib:	mov   al,[di]
		shl   al,cl
		mov   ah,es:[si]
		and   ax,0ff0h
		or    al,ah
		mov   es:[si],al
		ret

store_16:       store_byte
store_14:       store_byte
store_12:       store_byte
store_10:       store_byte
store_8:        store_byte
store_6:        store_byte
store_4:        store_byte
store_2:        store_byte
		ret

store_15:       store_byte
store_13:       store_byte
store_11:       store_byte
store_9:        store_byte
store_7:        store_byte
store_5:        store_byte
store_3:        store_byte
store_1:
; ecrit un quartet dans le lonib de la RAM pointee par es:si
; si cl=0, ecrit @di[3-0], sinon ecrit @di[7-4]
store_lonib:
		mov   al,[di]
		shr   al,cl
		mov   ah,es:[si]
		and   ax,0f00fh
		or    al,ah
		mov   es:[si],al
		ret

store_a:
; si cl=0, crire di en es:si, et di-1[3-0] en es:si+2[3-0]
; sinon, di[3-0] en es:si[7-4], di[7-0] en es:si+1[3-0], ...
		or    cl,cl
		jne   store_a1
		mov   ax,[di]
		mov   es:[si],ax    ; quartets 0, 1, 2, 3
		mov   al,[di-1]
		mov   ah,es:[si+2]
		and   ax,0f00fh
		or    al,ah
		mov   es:[si+2],al  ; quartet 4, -
		pop   cx
		pop   si
		pop   es
		NEXTI
store_a1:       mov   ax,[di]
		mov   bh,ah
		shl   ax,cl
		mov   bl,es:[si]
		and   bl,00fh
		or    al,bl
		mov   es:[si],ax    ; quartets -, 0, 1, 2
		mov   al,bh
		mov   ah,[di-1]
		shr   ax,cl
		mov   es:[si+2],al  ; quartets 3, 4
		pop   cx
		pop   si
		pop   es
		NEXTI



store_b:
; si cl=0, crire en es:si
; sinon, di[3-0] en es:si[7-4], et di[7-4] en es:si+1[3-0]
		mov   al,[di]
		or    cl,cl
		jne   store_b1
		mov   es:[si],al
		pop   cx
		pop   si
		pop   es
		NEXTI
store_b1:       xor   ah,ah
		shl   ax,4
		mov   bx,es:[si]
		and   bx,0f00fh
		or    ax,bx
		mov   es:[si],ax
		pop   cx
		pop   si
		pop   es
		NEXTI



store_w:
; mise  jour registre
		call  maj_w
; si cl=0, crire di en es:si, et di-1[3-0] en es:si+2[3-0]
; sinon, di[3-0] en es:si[7-4], di[7-0] en es:si+1[3-0], ...
		or    cl,cl
		jne   store_w1
		mov   ax,[di]
		mov   es:[si],ax
		mov   ax,[di+2]
		mov   es:[si+2],ax
		mov   ax,[di+4]
		mov   es:[si+4],ax
		mov   ax,[di+6]
		mov   es:[si+6],ax
		pop   cx
		pop   si
		pop   es
		NEXT
store_w1:       mov   ax,[di]        ; ax = [ 3 2 1 0 ]
		mov   bh,ah          ; bh = [ 3 2 ]
		shl   ax,4           ; ax = [ 2 1 0 - ]
		mov   bl,es:[si]     ; bl = [ x x ]
		and   bl,00fh        ; bl = [ - x ]
		or    al,bl          ; ax = [ 2 1 0 x ]
		mov   es:[si],ax     ; quartets 0, 1, 2
		; ici, bh[7-4] contient le prochain quartet (3)

		mov   al,bh          ; al = [ 3 2 ]
		mov   bx,[di+2]      ; bx = [ 7 6 5 4 ]
		mov   ah,bl          ; ah = [ 5 4 ]
		shr   ax,4           ; ax = [ - 5 4 3 ]
		mov   dx,bx          ; dx = [ 7 6 5 4 ]
		shl   dx,4           ; dx = [ 6 5 4 - ]
		mov   ah,dh          ; ax = [ 6 5 4 3 ]
		mov   es:[si+2],ax   ; quartets 3, 4, 5, 6

		mov   al,bh
		mov   bx,[di+4]
		mov   ah,bl
		shr   ax,4
		mov   dx,bx
		shl   dx,4
		mov   ah,dh
		mov   es:[si+4],ax   ; quartets 7, 8, 9, 10

		mov   al,bh
		mov   bx,[di+6]
		mov   ah,bl
		shr   ax,4
		mov   dx,bx
		shl   dx,4
		mov   ah,dh
		mov   es:[si+6],ax   ; quartets 11, 12, 13, 14

		shr   bh,4           ; bh = [ - 15 ]
		mov   al,es:[si+8]   ; al = [ x x]
		and   al,0f0h        ; al = [ x - ]
		or    al,bh          ; al = [ x 15]
		mov   es:[si+8],al   ; quartet 15

		pop   cx
		pop   si
		pop   es
		NEXT



		irp   CHAMP,<p, wp, xs, x, m, w>
		local store00
exec_store_&CHAMP&:
		push  es
		push  si
		push  cx
		call  get_pointer
		jc    store00      ; pour test criture ROMs !!!
		; es:si, cl : pointeur mmoire destination
		; ds:di : pointeur sur registre source
		or    bx,bx
		je    store00
		jmp   store_&CHAMP&
store00:        jmp   exec_store00
		endm



                align 2
_sto_A_D0_a:    exec_mems store A D0 a
_sto_C_D0_a:    exec_mems store C D0 a
_sto_A_D1_a:    exec_mems store A D1 a
_sto_C_D1_a:    exec_mems store C D1 a

exec_store_a:
		mov   ax,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bl-ax
		add   bx,bx
comment !
                cmp   bx,10
                jne   ea1
                cmp   ax,04000h
                jnc   exec_store_a0
ea1:
!
                cmp   bx,4
                jc    exec_store_a0
		mov   bx,[_tab_seg+bx]
                xchg  ax,bx
                or    ax,ax
                je    exec_store_a0
                mov   dx,es
                mov   es,ax
		shr   bx,1
                xchg  bx,di
                jnc   exec_store_a1
; bx[3-0] en es:di[7-4], bx[7-4] en es:di+1[3-0], ...
                mov   ax,[bx]       ; 3 2 1 0
                mov   bh,[bx-1]     ; - 4
                mov   bl,ah         ; - 4 3 2
		shl   ax,4          ;2 1 0 -
                shl   bx,4          ; 4 3 2 -
		mov   bl,es:[di]
		and   bl,00fh
		or    al,bl
		mov   es:[di],ax    ; quartets -, 0, 1, 2
		mov   es:[di+2],bh  ; quartets 3, 4
                mov   es,dx
                NEXTI
exec_store_a1:
; crire bx en es:di, et bx-1[3-0] en es:di+2[3-0]
                mov   ax,[bx]
                mov   es:[di],ax
                mov   al,[bx-1]
                mov   ah,es:[di+2]
		and   ax,0f00fh
		or    al,ah
                mov   es:[di+2],al
                mov   es,dx
exec_store_a0:  NEXTI


                align 2
_sto_A_D0_b:    exec_mems store A D0 b
_sto_C_D0_b:    exec_mems store C D0 b
_sto_A_D1_b:    exec_mems store A D1 b
_sto_C_D1_b:    exec_mems store C D1 b

exec_store_b:
		mov   ax,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bl-ax
		add   bx,bx
comment !
                cmp   bx,10
                jne   ea2
                cmp   ax,04000h
                jnc   exec_store_b0
ea2:
!
                cmp   bx,4
		mov   bx,[_tab_seg+bx]
                jc    exec_store_b0
                xchg  ax,bx
                or    ax,ax
                je    exec_store_b0
                mov   dx,es
                mov   es,ax
		shr   bx,1
                xchg  bx,di
                jnc   exec_store_b1
; ecrire bx[3-0] en es:di[7-4], et bx[7-4] en es:di+1[3-0]
                mov   al,[bx]       ; 1 0
                xor   ah,ah
		shl   ax,4          ; - 1 0 -
		mov   bx,es:[di]
		and   bx,0f00fh
		or    ax,bx
		mov   es:[di],ax
                mov   es,dx
                NEXTI
exec_store_b1:
; crire bx en es:di
                mov   al,[bx]
                mov   es:[di],al
                mov   es,dx
exec_store_b0:  NEXTI


                align 2
_sto_A_D0_s:    exec_mems store A D0 s
_sto_C_D0_s:    exec_mems store C D0 s
_sto_A_D1_s:    exec_mems store A D1 s
_sto_C_D1_s:    exec_mems store C D1 s

exec_store_s:
		mov   ax,[bx]
		mov   bl,[bx+2]
		and   bx,0fh
; cr un pointeur mmoire  partir d'une adresse bl-ax
		add   bx,bx
comment !
                cmp   bx,10
                jne   ea3
                cmp   ax,04000h
                jnc   exec_store_s0
ea3:
!
                cmp   bx,4
		mov   bx,[_tab_seg+bx]
                jc    exec_store_s0
                xchg  ax,bx
                or    ax,ax
                je    exec_store_s0
                mov   dx,es
                mov   es,ax
		shr   bx,1
                xchg  bx,di
                mov   al,[bx+7]
                jc    exec_store_s1
; ecrire al[7-4] en es:di[3-0]
                shr   al,4
		mov   ah,es:[di]
		and   ax,0f00fh
		or    al,ah
		mov   es:[di],al
                mov   es,dx
                NEXT
exec_store_s1:
; ecrire al [7-4] en es:di[7-4]
                mov   ah,es:[di]
                and   ax,0ff0h
                or    al,ah
                mov   es:[di],al
                mov   es,dx
exec_store_s0:  NEXT




exec_store_n:
                fetch_byte
                shr   al,4
                and   ax,15
                push  es
		push  si
		push  cx
		push  ax
		call  get_pointer
		jc    exec_store0     ; pour test criture ROMs !!!
		or    bx,bx
		je    exec_store0
		pop   bx
		; es:si, cl : pointeur mmoire,
		; ds:di : pointeur sur registre (source ou destination)
		; bx: nbre d'octets-1
		jmp   store_n
exec_store0:    pop   ax
exec_store00:   pop   cx
		pop   si
		pop   es
		NEXT

exec_store00ab: pop   cx
		pop   si
		pop   es
		NEXTI

err_store0:     pop   ax
err_store00:    pop   cx
		pop   si
		pop   es
		mov   ax,-2
		jmp   retour







; dfinitions du reste du code
		build_store store

; -----------------------------------------







; dfinitions des points d'entres
		irp   CHAMP,<p, wp, xs, x, m, w, n>

_lod_A_D0_&CHAMP&:      exec_mem load A D0 CHAMP
_lod_C_D0_&CHAMP&:      exec_mem load C D0 CHAMP
_sto_A_D0_&CHAMP&:      exec_mem store A D0 CHAMP
_sto_C_D0_&CHAMP&:      exec_mem store C D0 CHAMP
_lod_A_D1_&CHAMP&:      exec_mem load A D1 CHAMP
_lod_C_D1_&CHAMP&:      exec_mem load C D1 CHAMP
_sto_A_D1_&CHAMP&:      exec_mem store A D1 CHAMP
_sto_C_D1_&CHAMP&:      exec_mem store C D1 CHAMP

		endm


		end

